/* Simple program to use readline() to gather up input and write to stdout */
#include <stdio.h>

/* #define TEST */

main(argc,argv)
int argc;
char **argv;
{
  int nread, nline, fdin=(-1), fdout=(-1), i;
  char line[1024], *c, *rl_gets(), prompt[20], *strcpy();

#ifdef TEST
  fprintf(stderr, "Child here: I'm alive! argc = %d\n", argc);
#endif

/* Process the input arguments */
  for (i = 1; i < argc; i++) {

/* prompt input descriptor? (-in) */
    if (strcmp(argv[i], "-in") == 0) {
      if (++i >= argc) usage(argv[0]);
      fdin = atoi(argv[i]);
#ifdef TEST
      fprintf(stderr,"Child here: got %d for fdin\n", fdin);
#endif
      continue;
    }

/* completed line out put descriptor? (-out) */
    if (strcmp(argv[i], "-out") == 0) {
      if (++i >= argc) usage(argv[0]);
      fdout = atoi(argv[i]);
#ifdef TEST
      fprintf(stderr,"Child here: got %d for fdout\n", fdout);
#endif
      continue;
    }

  }

/* Tell parent who we are */
  write(fdout, "mongoin", 8);

/* Go off and spend the rest of our life reading and writing */
  while(1) {

/* Get a prompt */
#ifdef TEST
    fprintf(stderr,"Child: waiting on prompt...\n");
#endif
    nread = read(fdin, prompt, 20);
    prompt[nread] = '\0';

/* And read a processed line */
#ifdef TEST
    fprintf(stderr,"Child: waiting on rl_gets()...\n");
#endif
    c = rl_gets(prompt, line);
    nread = strlen(line);
    line[nread++] = '\0';
#ifdef TEST
    fprintf(stderr,"Child: got line '%s'\n", line);
#endif

/* End of file? */
    if(c == NULL) {
#ifdef TEST
      fprintf(stderr,"Child EOF\n");
#endif
      line[0] = EOF;
      write(fdout, line, 1);
    }

/* Send it back to the parent */
    write(fdout, line, nread);
  }
}

/* A static variable for holding the line. */
static char *line_read = (char *)NULL;
     
/* Read a string, and return a pointer to it.  Returns NULL on EOF. */
char *rl_gets (prompt, myline)
char *prompt, *myline;
{
  char *strcpy(), *readline();
  /* If the buffer has already been allocated, return the memory
     to the free pool. */
  if (line_read)
    {
      free (line_read);
      line_read = (char *)NULL;
    }

  /* Get a line from the user. */
  line_read = readline (prompt);

  /* If the line has any text in it, save it on the history. */
  if (line_read && *line_read) add_history (line_read);

  if(line_read == NULL) return(NULL);
  strcpy(myline, line_read);
  return (myline);
}

usage(id)
char *id;
{
  fprintf(stderr,"Usage %s [-pfd prompt_fd]\n",id);
  exit(1);
}

