CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
* Routines to sort out desired device and drivers
*     NUMDEV /  TERMOUT = T            NUMDEV / TERMOUT = F
*              -------------------------------------------------
*	N	Device			 N	Device
*	1	Retrographics 640	-1	Versatec (vertical)
*	2	DEC VT125		-2	Versatec (horizontal)
*	3	Tektronix 4010		-3	Printronix (vertical)
*	4       Grinnell 270		-4	Printronix (horizontal)
*	5       HP2648A			-5	Laser Printer (vertical)
*	6	Sun Windows		-6	Laser Printer (horizontal)
*	7	X Windows
* For printers NUMDEV < 0, the device is (-NUMDEV-1)/2 and MOD(-NUMDEV,2)
* indicates whether orientation has dX < dY.

      SUBROUTINE MGODEVICE(N)
      INCLUDE 'mongo.par'
      NUMDEV = N
      RETURN
      END

      SUBROUTINE MGOSETUP(N)
      INCLUDE 'mongo.par'
      IF(TERMOPEN) THEN
          CALL MGOTCLOSE
          TERMOPEN = .FALSE.
      END IF
      IF(N.GT.0) TERMOPEN = .TRUE.
      NUMDEV = N
      IF(NUMDEV.GT.0) THEN
          CALL MGOTSETUP
      ELSE IF(NUMDEV.LT.0) THEN
          CALL MGOPSETUP
      END IF
      RETURN
      END

      SUBROUTINE MGOTSETUP
      INCLUDE 'mongo.par'
      N = NUMDEV
      IF(N.LT.1.OR.N.GT.7) THEN
          CALL MGOERR('SETUP: Unknown type of terminal')
          RETURN
      END IF
      GOTO (1,2,3,4,5,6,7) NUMDEV
1     CALL MGORETROSETUP
      RETURN
2     CALL MGOVT125SETUP
      RETURN
3     CALL MGOT4010SETUP
      RETURN
4     CALL MGOGRSETUP
      RETURN
5     CALL MGOHPSETUP
      RETURN
6     CALL MGOSUNSETUP
      RETURN
7     CALL MGOXSETUP
      RETURN
      END

      SUBROUTINE MGOTSELECT
      INCLUDE 'mongo.par'
      IF(NUMDEV.LT.1.OR.NUMDEV.GT.7) RETURN
      GOTO (1,2,3,4,5,6,7) NUMDEV
1     CALL MGORETROSELECT
      RETURN
2     CALL MGOVT125SELECT
      RETURN
3     CALL MGOT4010SELECT
      RETURN
4     CALL MGOGRSELECT
      RETURN
5     CALL MGOHPSELECT
      RETURN
6     CALL MGOSUNSELECT
      RETURN
7     CALL MGOXSELECT
      RETURN
      END

      SUBROUTINE MGOTLINE(IX1,IY1,IX2,IY2)
      INCLUDE 'mongo.par'
      N = NUMDEV
      IF(N.LT.1.OR.N.GT.7) THEN
          CALL MGOERR('LINE: Unknown type of terminal')
          RETURN
      END IF
      GOTO (1,2,3,4,5,6,7) N
1     CALL MGORETROLINE(IX1,IY1,IX2,IY2)
      RETURN
2     CALL MGOVT125LINE(IX1,IY1,IX2,IY2)
      RETURN
3     CALL MGOT4010LINE(IX1,IY1,IX2,IY2)
      RETURN
4     CALL MGOGRLINE(IX1,IY1,IX2,IY2)
      RETURN
5     CALL MGOHPLINE(IX1,IY1,IX2,IY2)
      RETURN
6     CALL MGOSUNLINE(IX1,IY1,IX2,IY2)
      RETURN
7     CALL MGOXLINE(IX1,IY1,IX2,IY2)
      RETURN
      END

      SUBROUTINE MGOTRELOC(IX1,IY1)
      INCLUDE 'mongo.par'
      N = NUMDEV
      IF(N.LT.1.OR.N.GT.7) THEN
          CALL MGOERR('RELOC: Unknown type of terminal')
          RETURN
      END IF
      GOTO (1,2,3,4,5,6,7) N
1     CALL MGORETRORELOC(IX1,IY1)
      RETURN
2     CALL MGOVT125RELOC(IX1,IY1)
      RETURN
3     CALL MGOT4010RELOC(IX1,IY1)
      RETURN
4     CALL MGOGRRELOC(IX1,IY1)
      RETURN
5     CALL MGOHPRELOC(IX1,IY1)
      RETURN
6     CALL MGOSUNRELOC(IX1,IY1)
      RETURN
7     CALL MGOXRELOC(IX1,IY1)
      RETURN
      END

      SUBROUTINE MGOTDRAW(IX1,IY1)
      INCLUDE 'mongo.par'
      N = NUMDEV
      IF(N.LT.1.OR.N.GT.7) THEN
          CALL MGOERR('DRAW: Unknown type of terminal')
          RETURN
      END IF
      GOTO (1,2,3,4,5,6,7) N
1     CALL MGORETRODRAW(IX1,IY1)
      RETURN
2     CALL MGOVT125DRAW(IX1,IY1)
      RETURN
3     CALL MGOT4010DRAW(IX1,IY1)
      RETURN
4     CALL MGOGRDRAW(IX1,IY1)
      RETURN
5     CALL MGOHPDRAW(IX1,IY1)
      RETURN
6     CALL MGOSUNDRAW(IX1,IY1)
      RETURN
7     CALL MGOXDRAW(IX1,IY1)
      RETURN
      END

      SUBROUTINE MGOTCHAR(N,C)
      INCLUDE 'mongo.par'
      character*(*) c
      K = NUMDEV
      IF(K.LT.1.OR.K.GT.7) THEN
          CALL MGOERR('CHAR: Unknown type of terminal')
          RETURN
      END IF
      GOTO (1,2,3,4,5,6,7) K
1     CALL MGORETROCHAR(n,c)
      RETURN
2     CALL MGOVT125CHAR(n,c)
      RETURN
3     CALL MGOT4010CHAR(n,c)
      RETURN
4     CALL MGOGRCHAR(n,c)
      RETURN
5     CALL MGOHPCHAR(n,c)
      RETURN
6     CALL MGOSUNCHAR(n,c)
      RETURN
7     CALL MGOXCHAR(n,c)
      RETURN
      END

      SUBROUTINE MGOTLTYPE(ILT)
      INCLUDE 'mongo.par'
      N = NUMDEV
      IF(N.LT.1.OR.N.GT.7) THEN
          CALL MGOERR('LTYPE: Unknown type of terminal')
          RETURN
      END IF
      GOTO (1,2,3,4,5,6,7) N
1     CALL MGORETROLTYPE(ILT)
      RETURN
2     CALL MGOVT125LTYPE(ILT)
      RETURN
3     CALL MGOT4010LTYPE(ILT)
      RETURN
4     CALL MGOGRLTYPE(ILT)
      RETURN
5     CALL MGOHPLTYPE(ILT)
      RETURN
6     CALL MGOSUNLTYPE(ILT)
      RETURN
7     CALL MGOXLTYPE(ILT)
      RETURN
      END

      SUBROUTINE MGOTLWEIGHT(ILW)
      INCLUDE 'mongo.par'
      N = NUMDEV
      IF(N.LT.1.OR.N.GT.7) THEN
          CALL MGOERR('LWEIGHT: Unknown type of terminal')
          RETURN
      END IF
      GOTO (1,2,3,4,5,6,7) N
 1    RETURN
 2    RETURN
 3    RETURN
 4    RETURN
 5    RETURN
 6    RETURN
 7    CALL MGOXLWEIGHT(ILW)
      RETURN
      END

      SUBROUTINE MGOTCOLOR(IC)
      INCLUDE 'mongo.par'
      N = NUMDEV
      IF(N.LT.1.OR.N.GT.7) THEN
          CALL MGOERR('COLOR: Unknown type of terminal')
          RETURN
      END IF
      GOTO (1,2,3,4,5,6,7) N
1     RETURN
2     RETURN
3     RETURN
4     CALL MGOGRCOLOR(IC)
      RETURN
5     RETURN
6     RETURN
7     CALL MGOXCOLOR(IC)
      RETURN
      END

      SUBROUTINE MGOTPALETTE(IC)
      INCLUDE 'mongo.par'
      N = NUMDEV
      IF(N.LT.1.OR.N.GT.7) THEN
          CALL MGOERR('COLOR: Unknown type of terminal')
          RETURN
      END IF
      GOTO (1,2,3,4,5,6,7) N
1     RETURN
2     RETURN
3     RETURN
4     RETURN
5     RETURN
6     RETURN
7     CALL MGOXPALETTE(IC,PALETTE(1,IC))
      RETURN
      END

      SUBROUTINE MGOTFILL(IFILL,IRELOC)
      INCLUDE 'mongo.par'
      N = NUMDEV
      IF(N.LT.1.OR.N.GT.7) THEN
          CALL MGOERR('COLOR: Unknown type of terminal')
          RETURN
      END IF
      GOTO (1,2,3,4,5,6,7) N
1     RETURN
2     RETURN
3     RETURN
4     RETURN
5     RETURN
6     RETURN
7     CALL MGOXFILL(IFILL,IRELOC)
      RETURN
      END

      SUBROUTINE MGOTERASE
      INCLUDE 'mongo.par'
      N = NUMDEV
      IF(N.LT.1.OR.N.GT.7) THEN
          CALL MGOERR('ERASE: Unknown type of terminal')
          RETURN
      END IF
      GOTO (1,2,3,4,5,6,7) N
1     CALL MGORETROERASE
      RETURN
2     CALL MGOVT125ERASE
      RETURN
3     CALL MGOT4010ERASE
      RETURN
4     CALL MGOGRERASE
      RETURN
5     CALL MGOHPERASE
      RETURN
6     CALL MGOSUNERASE
      RETURN
7     CALL MGOXERASE
      RETURN
      END

      SUBROUTINE MGOTBITINIT(IXA,IYA,IXB,IYB,IALG,START)
      COMMON /TBITCLIP/ IX1, IX2, IY1, IY2
      IX1 = IXA
      IY1 = IYA
      IX2 = IXB
      IY2 = IYB
      RETURN
      END

      SUBROUTINE MGOTBITS(IXA,IYA,NX,NY,BITS)
      INTEGER*2 BITS(NX,NY)
      COMMON /TBITCLIP/ IX1, IX2, IY1, IY2
      DO 10 J = 1,NY
         IY = IYA + J - 1 
         IF(IY.GT.IY2.OR.IY.LT.IY1) GOTO 10
         DO 11 I = 1,NX
            IF(BITS(I,J).EQ.1) THEN
               IX = IXA + I - 1
               IF(IX.GT.IX2.OR.IX.LT.IX1) GOTO 11
               CALL MGOTLINE(IX, IY, IX, IY)
            END IF
 11      CONTINUE
 10   CONTINUE
      RETURN
      END

      SUBROUTINE MGOCURSOR(XA,YA,IREAD)
      INCLUDE 'mongo.par'
C IREAD = 0/1 to put/read the cursor
C Error to read the cursor from a hardcopy device, ok to put (relocate)
      IF(IREAD.EQ.0) THEN
          X = GX1 + (GX2-GX1)*(XA-X1)/(X2-X1)
          Y = GY1 + (GY2-GY1)*(YA-Y1)/(Y2-Y1)
          IF(ABS(X).GT.1E6.OR.ABS(Y).GT.1E6) THEN
              CALL MGOERR('Cursor position out of range')
              RETURN
          END IF
          IX = NINT(X)
          IY = NINT(Y)
      END IF
      N = NUMDEV
      IF(N.LT.1) THEN
          IF(IREAD.EQ.1) THEN
              CALL MGOERR('CURSOR: Cannot read hardcopy cursor')
              RETURN
          ELSE
              GOTO 10
          END IF
      END IF
      IF(N.GT.7) THEN
          CALL MGOERR('CURSOR: Unknown type of terminal')
          RETURN
      END IF
      GOTO (1,2,3,4,5,6,7) N
1     CALL MGORETROCURS(IX,IY,IREAD)
      GOTO 10
2     CALL MGOVT125CURS(IX,IY,IREAD)
      GOTO 10
3     CALL MGOT4010CURS(IX,IY,IREAD)
      GOTO 10
4     CALL MGOGRCURS(IX,IY,IREAD)
      GOTO 10
5     CALL MGOHPCURS(IX,IY,IREAD)
      GOTO 10
6     CALL MGOSUNCURS(IX,IY,IREAD)
      GOTO 10
7     CALL MGOXCURS(IX,IY,IREAD)
      GOTO 10
10    CONTINUE
      IF(IREAD.GE.1) THEN
          CXP = X1 + (X2-X1)*(IX-GX1)/(GX2-GX1)
          CYP = Y1 + (Y2-Y1)*(IY-GY1)/(GY2-GY1)
          XA = CXP
          YA = CYP
      ELSE
          CXP = XA
          CYP = YA
      END IF
      CALL MGORELOCATE(CXP,CYP)
      RETURN
      END

      SUBROUTINE MGOTIDLE
      INCLUDE 'mongo.par'
      N = NUMDEV
      IF(N.LT.1.OR.N.GT.7) THEN
          CALL MGOERR('IDLE: Unknown type of terminal')
          RETURN
      END IF
      GOTO (1,2,3,4,5,6,7) N
1     CALL MGORETROIDLE
      RETURN
2     CALL MGOVT125IDLE
      RETURN
3     CALL MGOT4010IDLE
      RETURN
4     CALL MGOGRIDLE
      RETURN
5     CALL MGOHPIDLE
      RETURN
6     CALL MGOSUNIDLE
      RETURN
7     CALL MGOXIDLE
      RETURN
      END

      SUBROUTINE MGOTCLOSE
      INCLUDE 'mongo.par'
      IF(.NOT.TERMOPEN) RETURN
      N = NUMDEV
      IF(N.LT.1.OR.N.GT.7) THEN
          CALL MGOERR('CLOSE: Unknown type of terminal')
          RETURN
      END IF
      GOTO (1,2,3,4,5,6,7) N
1     CALL MGOTTCLOSE
      RETURN
2     CALL MGOTTCLOSE
      RETURN
3     CALL MGOT4010CLOSE
      RETURN
4     CALL MGOGRCLOSE
      RETURN
5     CALL MGOTTCLOSE
      RETURN
6     CALL MGOSUNWINCLOSE
      RETURN
7     CALL MGOXWINCLOSE
      RETURN
      END

      SUBROUTINE MGOPSETUP
      INCLUDE 'mongo.par'
      N = -NUMDEV
      IF(N.LT.1.OR.N.GT.6) THEN
          CALL MGOERR('SETUP: Unknown type of printer')
          RETURN
      END IF
      GOTO (1,2,3,4,5,6) N
1     CALL MGOVTSETUP
      RETURN
2     CALL MGOVTSWAPXY
      RETURN
3     CALL MGOPXSETUP
      RETURN
4     CALL MGOPXSWAPXY
      RETURN
5     CALL MGOLGSETUP
      RETURN
6     CALL MGOLGSWAPXY
      RETURN
      END

      SUBROUTINE MGOPAGE(IPAGE)
      INCLUDE 'mongo.par'
      IDEV = (-NUMDEV+1)/2
      IF(IDEV.LT.1.OR.IDEV.GT.3) THEN
          CALL MGOERR('PAGE: Unknown type of printer')
          RETURN
      END IF
      GOTO (1,2,3) IDEV
1     CALL MGOVTPAGE(IPAGE)
      RETURN
2     CALL MGOPXPAGE(IPAGE)
      RETURN
3     CALL MGOLGPAGE(IPAGE)
      RETURN
      END
