CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE MGOSAVELINE(LINE,ERROR)
      INCLUDE 'vocab.par'
      CHARACTER*(*) LINE
      LOGICAL ERROR
      INLEN = MGOLENC(LINE) + 1
      IF(INLEN+BUFEND.GE.MACEND) THEN
          CALL MGOERR(' Command buffer overflow')
          ERROR = .TRUE.
          RETURN
      END IF
* Append this command
      COMBUF(BUFEND) = CHAR(INLEN)
      DO 30 I = 1,INLEN-1
30    COMBUF(I+BUFEND) = LINE(I:I)
      MACLEN(1) = MACLEN(1) + 1
      BUFEND = BUFEND + INLEN
      RETURN
      END

      SUBROUTINE MGOSTARTINS(REST,ERROR)
      CHARACTER*(*) REST
      CHARACTER*20 PAR
      LOGICAL ERROR
      REAL*8 ARG
      COMMON /MGOCINSERT/ ILOC, NAFTER
      INCLUDE 'vocab.par'
* Find how many existing instructions to skip
      CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
      IF(LENPAR.EQ.0) THEN
          ILOC = BUFEND
          NAFTER = 0
      ELSE
          CALL MGONUMARG(PAR,LENPAR,ARG,ERROR)
          IF(ERROR) RETURN
          INSKIP = MIN(NINT(ARG)-1,MACLEN(1))
* Find the byte location of where to start inserting
          ILOC = MACBEG(1)
          DO 10 I = 1,INSKIP
10        ILOC = ILOC + ICHAR(COMBUF(ILOC))
          NAFTER = BUFEND - ILOC
      END IF
* Start inserting at ILOC and push along NAFTER bytes
      RETURN
      END

      SUBROUTINE MGOINSERT(LINE,ERROR)
      CHARACTER*(*) LINE
      LOGICAL ERROR
      COMMON /MGOCINSERT/ ILOC, NAFTER
      INCLUDE 'vocab.par'
      INCLUDE 'luns.par'
      INLEN = MGOLENC(LINE) + 1
      IF(INLEN+ILOC+NAFTER.GE.MACEND) THEN
          CALL MGOERR(' Command buffer overflow')
          ERROR = .TRUE.
          RETURN
      END IF
* Move commands following insertion spot
      DO 20 I = NAFTER+ILOC-1,ILOC,-1
20    COMBUF(I+INLEN) = COMBUF(I)
* Insert this one
      COMBUF(ILOC) = CHAR(INLEN)
      DO 30 I = 1,INLEN-1
30    COMBUF(I+ILOC) = LINE(I:I)
      MACLEN(1) = MACLEN(1) + 1
      BUFEND = BUFEND + INLEN
      ILOC = ILOC + INLEN
      RETURN
      END

      SUBROUTINE MGODELETE(REST,ERROR)
      INCLUDE 'vocab.par'
      CHARACTER*(*) REST
      CHARACTER*20 PAR
      LOGICAL ERROR
      REAL*8 ARG
      IF(MACLEN(1).EQ.0) RETURN
      CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
      IF(LENPAR.EQ.0) THEN
          L1 = MACLEN(1)
          L2 = L1
      ELSE
          CALL MGONUMARG(PAR,LENPAR,ARG,ERROR)
          IF(ERROR) RETURN
          L1 = NINT(ARG)
          IF(NEXTPAR.LE.LEN(REST)) THEN
              CALL MGOPARSE(REST(NEXTPAR:),PAR,LENPAR,NEXTPAR)
              IF(LENPAR.EQ.0) THEN
                  L2 = L1
              ELSE
                  CALL MGONUMARG(PAR,LENPAR,ARG,ERROR)
                  IF(ERROR) RETURN
                  L2 = NINT(ARG)
              END IF
          ELSE
              L2 = L1
          END IF
      END IF
      L1 = MIN(MAX(L1,1),MACLEN(1))
      L2 = MIN(MAX(L2,1),MACLEN(1))
      IP1 = 1
      DO 10 I = 1,L1-1
10    IP1 = IP1 + ICHAR(COMBUF(IP1))
      IP2 = IP1
      NDEL = 0
      DO 11 I = L1,L2
      NDEL = NDEL + 1
11    IP2 = IP2 + ICHAR(COMBUF(IP2))
      DO 20 I = IP2,BUFEND
20    COMBUF(I-IP2+IP1) = COMBUF(I)
      MACLEN(1) = MACLEN(1) - NDEL
      BUFEND = BUFEND - IP2 + IP1
      RETURN
      END

      SUBROUTINE MGOSTARTMAC(REST,ERROR)
      CHARACTER*(*) REST
      CHARACTER*19 NAME
      LOGICAL ERROR
      INCLUDE 'vocab.par'
* Get name of macro
      CALL MGOPARSE(REST,NAME,LENPAR,NEXTPAR)
      IF(LENPAR.EQ.0) THEN
          CALL MGOERR('define requires a macro name')
          ERROR = .TRUE.
          RETURN
      END IF
      CALL MGOLOWER(NAME)
      IF(NMAC.GE.MAXVOCAB-NBUILTIN) THEN
          CALL MGOERR(' Too many macros')
          ERROR = .TRUE.
          RETURN
      END IF
* Check to see that the macro name is unique
      DO 10 J = 1,MAXVOCAB
      NCOMP = MIN(LENPAR,MGOLENC(VOCAB(J)(2:)))
      IF(NAME(:NCOMP).EQ.VOCAB(J)(2:NCOMP+1)) THEN
          ERROR = .TRUE.
          CALL MGOERR2('Ambiguous name: ',NAME)
          RETURN
      END IF
10    CONTINUE
      NMAC = NMAC + 1
      MACBEG(NMAC) = MACEND
      MACLEN(NMAC) = 0
      VOCAB(NBUILTIN+NMAC) = ' '//NAME
      RETURN
      END

      SUBROUTINE MGORENAMAC(REST,ERROR)
      CHARACTER*(*) REST
      CHARACTER*19 NAME, NEWNAME
      LOGICAL ERROR
      INCLUDE 'vocab.par'
* Get name of macro
      CALL MGOPARSE(REST,NAME,L1,NEXTPAR)
* Get new name for macro
      IF(L1.GT.0) CALL MGOPARSE(REST(NEXTPAR:),NEWNAME,L2,NEXTPAR)
      IF(L1.EQ.0 .OR. L2.EQ.0) THEN
          CALL MGOERR('Syntax: RENAME old_name new_name')
          ERROR = .TRUE.
          RETURN
      END IF
      CALL MGOLOWER(NAME)
      CALL MGOLOWER(NEWNAME)

* Check to see that the macro name exists and the new one is unique
      IEXIST = 0
      DO 10 J = 1,MAXVOCAB
         L = MGOLENC(VOCAB(J)(2:))
         NCOMP = MIN(L1,L)
         IF(NAME(:NCOMP).EQ.VOCAB(J)(2:NCOMP+1)) THEN
            IF(IEXIST.EQ.0) THEN
               IEXIST = J
            ELSE
               IEXIST = -1
            END IF
         END IF
         NCOMP = MIN(L2,L)
         IF(NEWNAME(:NCOMP).EQ.VOCAB(J)(2:NCOMP+1)) THEN
            ERROR = .TRUE.
            CALL MGOERR2('Ambiguous name: ',NEWNAME)
            RETURN
         END IF
10    CONTINUE
      IF(IEXIST.LT.0) THEN
         ERROR = .TRUE.
         CALL MGOERR2('Ambiguous name: ',NAME)
         RETURN
      ELSE IF(IEXIST.EQ.0) THEN
         ERROR = .TRUE.
         CALL MGOERR2('Unknown macro or command: ',NAME)
         RETURN
      ELSE IF(IEXIST.LE.NBUILTIN) THEN
         ERROR = .TRUE.
         CALL MGOERR('Only macros can be renamed')
         RETURN
      END IF

      VOCAB(IEXIST) = ' '//NEWNAME
      RETURN
      END

      SUBROUTINE MGOSAVEMAC(LINE,ERROR)
      CHARACTER*(*) LINE
      LOGICAL ERROR
      INCLUDE 'vocab.par'
      MLEN = MGOLENC(LINE) + 1
      IF(MLEN+BUFEND.GE.MACEND) THEN
          CALL MGOERR(' Macro buffer overflow')
          ERROR = .TRUE.
          RETURN
      END IF
      COMBUF(MACEND) = CHAR(MLEN)
      DO 20 I = 1,MLEN-1
20    COMBUF(MACEND-MLEN+I) = LINE(I:I)
      MACEND = MACEND - MLEN
      MACLEN(NMAC) = MACLEN(NMAC) + 1
      RETURN
      END
