CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE MGOBOX(LABELX,LABELY)
      INCLUDE 'mongo.par'
      INCLUDE 'luns.par'
      COMMON /MGOGRIDPAR/ ASMALLX, ABIGX, ASMALLY, ABIGY
      LTSAVE = LTYPE
      CALL MGOSETLTYPE(0)
      NOLABELX = 3
      IF(LABELX.LT.0) NOLABELX = -3
      CALL MGOAXIS(X1,X2,ASMALLX,ABIGX,GX1,GY1,GX2,GY1,LABELX,0)
      CALL MGOAXIS(X1,X2,ASMALLX,ABIGX,GX1,GY2,GX2,GY2,NOLABELX,1)
      NOLABELY = 3
      IF(LABELY.LT.0) NOLABELY = -3
      CALL MGOAXIS(Y1,Y2,ASMALLY,ABIGY,GX1,GY1,GX1,GY2,LABELY,1)
      CALL MGOAXIS(Y1,Y2,ASMALLY,ABIGY,GX2,GY1,GX2,GY2,NOLABELY,0)
      CALL MGOSETLTYPE(LTSAVE)
      RETURN
      END

      SUBROUTINE MGOGRID(IFREQ)
      INCLUDE 'mongo.par'
      COMMON /MGOGRIDPAR/ ASMX, ABIGX, ASMY, ABIGY
      REAL PAR(5)
      EXTERNAL MGOGRIDFN
C IFREQ = 0 for lines at labelled ticks, 1 for all ticks
      PAR(4) = 0
      PAR(5) = 1
      PAR(2) = IFREQ
      ASMALL = 0
      ABIG = 0
      PAR(1) = GY2 - GY1
      PAR(3) = 0
      CALL MGOAXISTICK(X1,X2,ASMX,ABIGX,GX1,GY1,GX2,GY1,PAR,MGOGRIDFN)
      PAR(1) = GX2 - GX1
      PAR(3) = 1
      CALL MGOAXISTICK(Y1,Y2,ASMY,ABIGY,GX1,GY1,GX1,GY2,PAR,MGOGRIDFN)
      RETURN
      END

      SUBROUTINE MGOTICKSIZE(ASX,ABX,ASY,ABY)
      INCLUDE 'mongo.par'
      COMMON /MGOGRIDPAR/ ASMALLX, ABIGX, ASMALLY, ABIGY
      ASMALLX = ASX
      ABIGX = ABX
      ASMALLY = ASY
      ABIGY = ABY
      RETURN
      END

      SUBROUTINE MGODEFGRID
      INCLUDE 'mongo.par'
      LTYPO = LTYPE
      CALL MGOSETLTYPE(1)
      CALL MGOGRID(0)
      CALL MGOSETLTYPE(LTYPO)
      RETURN
      END

      SUBROUTINE MGOAXIS(A1,A2,ASMALL,ABIG,AX1,AY1,AX2,AY2,LAB,ICLOCK)
C---------------------
C     Makes an axis labelled from A1 to A2 between (AX1,AY1), (AX2,AY2)
C     If ABIG > 0 use that for spacing of large ticks.
C     If ASMALL < 0 make a logarithmic axis, if ASMALL = 0, do the default
C     If ASMALL > 0 try to use that for the spacing of small ticks.
C     LAB codes how labels and ticks are to be drawn:
C     0: ticks, no labels (same as +3, included for 1983 compatibility)
C     Sign: + for ticks, - for no ticks
C     1: labels parallel to axis
C     2: labels perpendicular to axis
C     3: no labels
C     10's = Font selector: 0 for Roman, 1 for Plain, 2 for Tiny
C     100's = Format selector: 0 for Mongo, 1 for Formatted, 2/3 for dms/hms
C     LAB is 0 for no labels, odd for labels parallel to axis, and even for
C     perpendicular to axis. Use 1,2 for Roman; 3,4 for Plain and 4,5 for Tiny.
C     ANGLE determines the angle of the axis.
C     ICLOCK = 1 for clockwise ticks on the axis, 0 for counter
C---------------------
      INCLUDE 'mongo.par'
      REAL PAR(5)
      EXTERNAL MGOTICKLABEL, MGOTICK

      CALL MGOLINE(AX1,AY1,AX2,AY2)
      IF(A1.EQ.A2 .OR. EXPAND.LE.0) RETURN

      PAR(1) = ICLOCK
      PAR(5) = 0
      IF(LAB.GE.0) CALL MGOAXISTICK(A1,A2,ASMALL,ABIG,
     1				AX1,AY1,AX2,AY2,PAR,MGOTICK)
      L = MOD(IABS(LAB),10)
      IF(L.EQ.1.OR.L.EQ.2) THEN
          IF(L.EQ.1) THEN
              PAR(1) = 1
          ELSE
              PAR(1) = 2 * ICLOCK
          END IF
          PAR(2) = MOD(IABS(LAB)-1,100)
          PAR(3) = ICLOCK
* Choose floating point or exponential notation (-/+)
* and use 1/2/3/4 to indicate default/0.0/dms/hms notation
* Set PAR(5) to the number of decimal places required
          PAR(4) = -1
          AXB = AMAX1(ABS(A1),ABS(A2))
          AXS = ABS(A2-A1)/7
          IF(ASMALL.LT.0) THEN
              IF(AXB.GE.5) PAR(4) = 1
              PAR(5) = 0
          ELSE
              IF(AXB.LT.1E-4.OR.AXB.GT.1E5) PAR(4) = 1
              NSIG = INT(ALOG10(AXB)+101) - INT(ALOG10(AXS)+100)
              NDP = NSIG - INT(ALOG10(AXB)+100) + 99
              IF(IABS(LAB)/100.EQ.0) THEN
                  PAR(5) = NSIG
              ELSE IF(IABS(LAB)/100.EQ.1) THEN
                  IF(PAR(4).GT.0) THEN
                      PAR(5) = NSIG
                  ELSE
                      PAR(5) = MAX(NDP,0)
                  END IF
              ELSE IF(IABS(LAB)/100.EQ.2.OR.IABS(LAB)/100.EQ.3) THEN
                  IF(AXS.GT.1) THEN
                      PAR(5) = 0
                  ELSE IF(AXS.GT.1./60.) THEN
                      PAR(5) = 2
                  ELSE IF(AXS.GT.1./3600.) THEN
                      PAR(5) = 3
                  ELSE
                      PAR(5) = 4
                  END IF
              END IF
          END IF
          PAR(4) = PAR(4) * (1+IABS(LAB)/100)
          CALL MGOAXISTICK(A1,A2,ASMALL,ABIG,AX1,AY1,AX2,AY2,
     1			PAR,MGOTICKLABEL)
      END IF
      RETURN
      END

      SUBROUTINE MGOAXISTICK(A1,A2,ASMALL,ABIG,QX1,QY1,QX2,QY2,PAR,FUNC)
C---------------------
C     Makes an axis labelled from A1 to A2 between (QX1,QY1), (QX2,QY2)
C     If ASMALL < 0 make a logarithmic axis, if ASMALL = 0, do the default
C     If ASMALL > 0 try to use that for the spacing of small ticks.
C     If ABIG > 0 use that for spacing of large ticks.
C     Passes the x,y positions, the label, the tick size, and
C     the five parameters PAR to the function FUNC.
C---------------------
      INCLUDE 'mongo.par'
      REAL*8 AX1,AX2,STEP,TICK,OFF,VALUE
      INTEGER MAJOR, MINOR, LOGTICK(5,4)
      REAL PAR(5)
      EXTERNAL FUNC
      DATA MAJOR /1/, MINOR /0/
      DATA LOGTICK /1,1,1,1,1, 1,3,1,1,1, 1,2,5,1,1, 1,2,3,5,7/

      IF(A1.EQ.A2) RETURN
      IF(ASMALL.LT.0.AND.ABS(A1-A2).GT.30) RETURN
      ALEN = SQRT((QX2-QX1)*(QX2-QX1)+(QY2-QY1)*(QY2-QY1))
      IF(ALEN.LT.1) RETURN
      AX1 = DBLE(A1)
      AX2 = DBLE(A2)
      ANGSAVE = ANGLE
      IF(QY1.EQ.QY2) THEN
          IF(QX2.GT.QX1) THEN
              ANGLE = 0
          ELSE
              ANGLE = 180
          END IF
      ELSE IF(QX1.EQ.QX2) THEN
          IF(QY2.GT.QY1) THEN
              ANGLE = 90
          ELSE
              ANGLE = 270
          END IF
      ELSE
          ANGLE = 180/PI*ATAN2(QY2-QY1,QX2-QX1)
      END IF
      COSINE = COS(ANGLE*PI/180)
      SINE = SIN(ANGLE*PI/180)

      IF(ABIG.EQ.0.AND.ASMALL.GE.0) THEN
          NSMALL = 5
          IF(ABS(SINE).GT.ABS(COSINE)) THEN
              NLABEL = NINT(ALEN/(10*CWIDTH*CYDEF*EXPAND*EXPY))
          ELSE
              NLABEL = NINT(ALEN/(10*CWIDTH*CXDEF*EXPAND*EXPX))
          END IF
          NLABEL = MAX(NLABEL,4)
          DIFF = LOG10(ABS((A2 - A1)/NLABEL))
          IEXP = DIFF
          IF(DIFF.LT.0) IEXP = IEXP - 1
          AMANT = DIFF - IEXP
          IF(AMANT.LT..15) THEN
              NUM = 1
          ELSEIF(AMANT.LT..50) THEN
              NUM = 2
              NSMALL = 4
          ELSEIF(AMANT.LT..85) THEN
              NUM = 5
          ELSE
              NUM = 10
          END IF
          STEP = (NUM * 10.D0**IEXP)
          IF(ASMALL.GT.0) NSMALL = ABS(NINT(STEP/ASMALL))
      ELSEIF(ABIG.GT.0.AND.ASMALL.GT.0) THEN
          STEP = DBLE(ABIG)
          NSMALL = ABS(NINT(STEP/ASMALL))
      ELSEIF(ASMALL.LT.0) THEN
          NDECADE = DABS(AX2-AX1) + .99
          STEP = 1D0
          NSMALL = 10
          IF(NDECADE.LE.1) THEN
              ILOG = 4
          ELSE IF(NDECADE.EQ.2) THEN
              ILOG = 3
          ELSE IF(NDECADE.EQ.3) THEN
              ILOG = 2
          ELSE
              ILOG = 1
          END IF
      END IF

C fudge AX1 and AX2 to allow for unfavorable integer roundoff
      AX1 = AX1 - 1D-6*(AX2-AX1)
      AX2 = AX2 + 1D-6*(AX2-AX1)
      IF(AX2.LT.AX1) STEP = -STEP
      OFF = DINT(AX1/STEP)
      IF(AX1/STEP.LT.0) OFF = OFF - 1D0
      TICK = STEP * OFF

      DO 20 J = 1,1000
      DO 10 I = 1,NSMALL

      IF(ASMALL.GE.0) THEN
          VALUE = TICK + STEP*(I-1)/NSMALL
          IF(DABS(VALUE).LT.DABS(STEP*1D-12)) VALUE = 0D0
          XLEN = ALEN*(VALUE-AX1)/(AX2-AX1)
      ELSE
          VALUE = I * 10D0**TICK
          XLEN = ALEN*(DLOG10(VALUE)-AX1)/(AX2-AX1)
      END IF

      IF(XLEN.LT.-1) GOTO 10
      IF(XLEN.GT.ALEN) GOTO 21

      XPOS = XLEN*COSINE + QX1
      YPOS = XLEN*SINE + QY1

      IF(ASMALL.GE.0) THEN
          IF(I.EQ.1) THEN
              CALL FUNC(XPOS,YPOS,VALUE,MAJOR,PAR)
          ELSE
              CALL FUNC(XPOS,YPOS,VALUE,MINOR,PAR)
          END IF
      ELSE
          IFOUND = 0
          DO 900 K = 1,5
              IF(LOGTICK(K,ILOG).EQ.I) THEN
                  CALL FUNC(XPOS,YPOS,VALUE,MAJOR,PAR)
                  GOTO 10
              END IF
900       CONTINUE
          CALL FUNC(XPOS,YPOS,VALUE,MINOR,PAR)
      END IF

10    CONTINUE
      TICK = TICK + STEP
20    CONTINUE
21    CONTINUE
      ANGLE = ANGSAVE
      RETURN
      END

      SUBROUTINE MGOTICK(X,Y,VALUE,IMPORT,PAR)
C Tick's location is X,Y
C IMPORT determines whether a big or small tick
C PAR(1) = 1 for clockwise ticks on the axis, 0 for counter
C ANGLE determines the angle of the axis.
      INCLUDE 'mongo.par'
      REAL*8 VALUE
      REAL PAR(1)
      COSINE = COS(ANGLE*PI/180)
      SINE = SIN(ANGLE*PI/180)

      IF(PAR(1).LT.0.5) THEN
          BIG = CHEIGHT * CXDEF * EXPAND * EXPX
          TINY = .5 * CHEIGHT * CXDEF * EXPAND * EXPX
      ELSE
          BIG = -CHEIGHT * CXDEF * EXPAND * EXPX
          TINY = -.5 * CHEIGHT * CXDEF * EXPAND * EXPX
      END IF

      IF(IMPORT.EQ.0) THEN
          XTICK = -TINY*SINE + X
          YTICK =  TINY*COSINE + Y
      ELSE
          XTICK = -BIG*SINE + X
          YTICK =  BIG*COSINE + Y
      END IF

      CALL MGOLINE(X,Y,XTICK,YTICK)
      RETURN
      END

      SUBROUTINE MGOTICKLABEL(X,Y,VALUE,IMPORT,PAR)
C Label's location is X,Y, VALUE is the number output.
C PAR(1) is 0, 1, 2 for label to be left, center, or right justified
C PAR(2) = 0 for labels parallel to axis, and 1 for perpendicular to axis
C PAR(2) tens = 00,10,20              for Roman, Plain, Tiny fonts
C PAR(3) = 0 for clockwise labels on the axis, 1 for counter
C PAR(4) = -/0/+ for floating point/default/exponential notation
C PAR(4) = 1,2,3,4   for MONGO, 0.0, DMS, HMS, formats
C PAR(5) = number of significant digits for formats
C ANGLE determines the angle of the axis.
      INCLUDE 'mongo.par'
      REAL*8 VALUE
      REAL PAR(5)
      CHARACTER*40 STRING

      IF(IMPORT.EQ.0) RETURN

      LAB = NINT(PAR(2))
      IFONT = MOD(LAB,100) / 10
      COSINE = COS(ANGLE*PI/180)
      SINE = SIN(ANGLE*PI/180)

* Parallel
      IF(2*(LAB/2).EQ.LAB) THEN
         OFFSET = PARfudge * CHEIGHT * CYDEF * EXPAND * EXPY
* Perpendicular
      ELSE
         ANGLE = ANGLE - 90
C         OFFSET = 1./3. * CHEIGHT * CYDEF * EXPAND * AMIN1(EXPX,EXPY)
         OFFSET = PERfudge * CWIDTH * CXDEF * EXPAND * EXPX
      END IF
      IF(PAR(3).GT.0.5) OFFSET = -OFFSET
      XLABEL =  OFFSET*SINE + X
      YLABEL = -OFFSET*COSINE + Y

      NOTATION = NINT(PAR(4))
      NSIG = NINT(PAR(5))
      IASCII = 0
      MAXDIGIT = 10

      CALL MGONUMBER(VALUE,NCHAR,STRING,NOTATION,IASCII,
     1		MAXDIGIT,NSIG,IFONT)

      CALL MGOGSTRLEN(NCHAR,STRING,SLENGTH,SHEIGHT)
      DX = -0.5 * PAR(1) * SLENGTH
* Parallel
      IF(2*(LAB/2).EQ.LAB) THEN
          XS = DX*COSINE + XLABEL
          YS = DX*SINE + YLABEL
          CALL MGOGRELOCATE(XS,YS)
          CALL MGOGSTRING(NCHAR,STRING)
* Perpendicular
      ELSE
          XS = DX*SINE + XLABEL
          YS = -DX*COSINE + YLABEL
          CALL MGOGRELOCATE(XS,YS)
          CALL MGOGSTRING(NCHAR,STRING)
          ANGLE = ANGLE + 90
      END IF
      RETURN
      END

      SUBROUTINE MGOGRIDFN(X,Y,VALUE,IMPORT,PAR)
C Grid line's location is X,Y
C PAR(1) = length of grid line
C IMPORT determines whether a big or small tick
C PAR(2) = 0/1 for lines on major/all ticks
C PAR(3) = 0/1 for vertical/horizontal lines
      INCLUDE 'mongo.par'
      REAL*8 VALUE
      REAL PAR(3)

      IF(IMPORT.EQ.0.AND.PAR(2).NE.1) RETURN

      IF(PAR(3).GT.0.5) THEN
          XB = X + PAR(1)
          YB = Y
      ELSE
          XB = X
          YB = Y + PAR(1)
      END IF
      CALL MGOLINE(X,Y,XB,YB)
      RETURN
      END


      SUBROUTINE MGONUMBER(VAR,N,S,NOTATION,IASCII,MAXDIGIT,NSIG,IFONT)
C---------------------
C NUMBER converts the dp floating point number VAR to a string of characters.
C NOTATION = - for fp, 0 for default, + for exponential notation
C NOTATION = 1,2,3,4   for MONGO, 0.0, DMS, HMS, formats
C NSIG = Number of significant figures for non-mongo formats, 
C or number of decimal places for 0.0 format in floating point
C IASCII = 1 for 1E-7, 0 for superscripts, etc with backslash
C IFONT = 0,1,2 for Roman, Plain and Tiny
C---------------------
      real*8 var, x
      character bs
      logical fp, tenpower
      character*19 string
      character*5 zeros
      character*(*) s
      data zeros /'00000'/

      bs = char(92)
C Set the fonts
      if(ifont.eq.1) then
          s(1:3) = bs//bs//'P'
          n = 3
      else if(ifont.eq.2) then
          s(1:3) = bs//bs//'T'
          n = 3
      else
          n = 0
      end if

      x = var

C  Check for negative or zero number
      if(x.lt.0) then
          n = n + 1
          s(n:n) = '-'
          x = -x
      end if

C Decide whether the number is to be in fp or exponential format
      fp = notation .lt. 0
      iform = iabs(notation)
      if(notation.eq.0) then
          fp = x.eq.0 .or. (x.gt.1e-4.and.x.lt.1e5)
          iform = 1
      end if
           
C Round off the number
      if(x.gt.0) then
          if(iform.eq.1) then
              x = x + 0.5 * x * 10.**(-max(maxdigit,8))
          else if(iform.eq.2) then
              if(fp) then
                  x = x + 0.5 * 10.**(-nsig)
              else
                  x = x + 0.5 * x * 10.**(-nsig)
              end if
          else if(iform.eq.3.or.iform.eq.4) then
              if(nsig.eq.0) then
                  x = x + 0.5
              else if(nsig.le.2) then
                  x = x + 0.5/60
              else if(nsig.le.3) then
                  x = x + 0.5/3600
              else              
                  x = x + 0.5/36000
              end if
          end if
      end if

C Write the number
      if(iform.eq.3.or.iform.eq.4) then
          write(string,'(i3,i2.2,i3.3)') int(x), 
     1			mod(int(60*x),60), mod(int(36000*x),600)
      else
          write(string,'(d19.12)') x
      end if

C Put out the characters: (1) MONGO format, (2) 0.0, (3) DMS, (4) HMS

C DMS and HMS formats
      if(iform.eq.3.or.iform.eq.4) then
* Remove leading blanks
          if(string(1:1).ne.' ') then
              s(n+1:n+2) = string(1:2)
              n = n + 2
          else if(string(2:2).ne.' ') then
              s(n+1:n+1) = string(2:2)
              n = n + 1
          end if
          s(n+1:n+1) = string(3:3)
          n = n + 1
          if(iform.eq.3) then
              s(n+1:n+3) = bs//'r`'
              n = n + 3
          else
              s(n+1:n+3) = bs//'uh'
              n = n + 3
          end if
          if(nsig.eq.0) return
* Continue with minutes
          s(n+1:n+2) = string(4:5)
          n = n + 2
          if(iform.eq.3) then
              s(n+1:n+1) = ''''
              n = n + 1
          else
              s(n+1:n+3) = bs//'um'
              n = n + 3
          end if
          if(nsig.le.2) return
* Continue with seconds
          s(n+1:n+2) = string(6:7)
          n = n + 2
          if(nsig.gt.3) then
              s(n+1:n+4) = '.'//bs//'b.'//string(8:8)
              n = n + 4
          end if
          if(iform.eq.3) then
              s(n+1:n+1) = '"'
              n = n + 1
          else
              s(n+1:n+3) = bs//'us'
              n = n + 3
          end if
          if(nsig.gt.3) then
              s(n+1:n+1) = string(8:8)
              n = n + 1
          end if
          return
      end if                    

C Other formats
* Is the number zero?
      if(x.eq.0) then
          if(iform.eq.1 .or. (iform.eq.2.and.nsig.eq.0)) then
              s(n+1:n+1) = '0'
              n = n + 1
          else if(iform.eq.2) then
              s(n+1:n+3) = '0.0'
              n = n + 3
          end if
          return
      end if

* Get the exponent from +0.123456789012D+07
      read(string(17:19),'(i3)') iexp
* Determine how many digits to put out from mantissa (not counting zeros)
      if(iform.eq.2) then
          if(fp) then
              ndigit = iexp + nsig
          else
              ndigit = nsig
          end if
      else if(iform.eq.1) then
* Find the first "0000" in string (marking the end of the significant digits)
C          ndigit = 1
CC          do 10 i = 4,12
CC              if(string(i+1:i+3).eq.'000') goto 11
C          do 10 i = 4,11
C              if(string(i+1:i+4).eq.'0000') goto 11
C              ndigit = ndigit + 1
C10        continue
C11        continue
* Find the first "0000" in string (marking the end of the significant digits)
          ndigit = index(string(5:),'0000')
          if(ndigit.eq.0) ndigit = index(string(5:),'000')
          if(ndigit.eq.0) then
             ndigit = index(string(5:),'999')
             if(ndigit.eq.0) then
                ndigit = 8
             else
                if(string(ndigit+3:ndigit+3).eq.'9') then
                   string(ndigit+3:ndigit+3) = '1'
                   iexp = iexp + 1
                else
                   string(ndigit+3:ndigit+3) = 
     $                  char(ichar(string(ndigit+3:ndigit+3))+1)
                end if
             end if
          end if
      end if

      tenpower = .not.fp .and. iform.eq.1 .and.
     1		ndigit.eq.1 .and. string(4:4).eq.'1'

* Write the number
      if(tenpower) goto 30

      if(fp) then
          idpt = iexp
      else
          idpt = 1
      end if
* Write any leading 0.00000's
      if(idpt.le.0) then
          if(iform.eq.2) then
              n = n + 1
              s(n:n) = '0'
          end if
          if(iexp.lt.0) then
              s(n+1:n+1-iexp) = '.'//zeros
              n = n + 1 - iexp
          end if
      end if
* Transfer the digits from string to s, inserting a decimal where needed
      nwrite = max(ndigit,iexp)
      if(.not.fp) nwrite = ndigit
      do 20 i = 1,nwrite
          if(idpt.eq.0) then
              n = n + 1
              s(n:n) = '.'
          end if
          n = n + 1
          if(i.le.ndigit) then
              s(n:n) = string(3+i:3+i)
          else
              s(n:n) = '0'
          end if
          idpt = idpt - 1
20    continue

      if(fp) return

* If we need an exponent, get it here
30    continue
      if(iascii.eq.1) then
          n = n + 1
          s(n:n) = 'E'
      else
          if(tenpower) then
              s(n+1:n+5) = '10'//bs//bs//'u'
              n = n + 5
          else
              s(n+1:n+8) = bs//'g*10'//bs//bs//'u'
              n = n + 8
          end if
      end if
      write(string(17:19),'(i3.2)') iexp - 1
      if(string(17:17).eq.'-') then
          n = n + 1
          s(n:n) = '-'
      end if
      if(string(18:18).ne.'0') then
          n = n + 1
          s(n:n) = string(18:18)
      end if
      n = n + 1
      s(n:n) = string(19:19)
      if(iascii.eq.0) then
          s(n+1:n+3) = bs//bs//'d'
          n = n + 3
      end if
      return
      end
