CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE MGOCONNECT(X,Y,NXY)
      REAL X(1), Y(1)
      IF(NXY.LT.2) RETURN
      CALL MGORELOCATE(X(1),Y(1))
      DO 10 J = 2,NXY
          CALL MGODRAW(X(J),Y(J))
10    CONTINUE
      RETURN
      END

      SUBROUTINE MGOPOINTS(STYLE,NSTYLE,X,Y,NXY)
      INCLUDE 'mongo.par'
      REAL X(1), Y(1)
      INTEGER STYLE(1)
      REAL*8 CODE
      IF(NXY.LT.1) RETURN
      OLDEXP = EXPAND
      OLDANG = ANGLE
      IOLDCOL = ICOLOR
      DO 10 J = 1,NXY
          CALL MGORELOCATE(X(J),Y(J))
          IF(J.GT.NSTYLE) THEN
             NSIDE = NINT(PTYPE) / 10
             ISTYLE = MOD(NINT(PTYPE),10)
          ELSE
             CODE = STYLE(J)
             CALL MGOPTDECODE(NSIDE,ISTYLE,EXPO,ANG,ICOL,CODE)
             IF(NSIDE.EQ.0) THEN
                GOTO 10
             ELSE IF(NSIDE.LT.0) THEN
                NSIDE = NINT(PTYPE) / 10
                ISTYLE = MOD(NINT(PTYPE),10)
             END IF
             IF(EXPO.GT.0) EXPAND = OLDEXP*EXPO
             IF(ANG.GT.0) ANGLE = ANG
             IF(ICOL.GT.0) CALL MGOSETCOLOR(ICOL)
          END IF
          CALL MGOPOINT(NSIDE,ISTYLE)
10    CONTINUE
      EXPAND = OLDEXP
      ANGLE = OLDANG
      CALL MGOSETCOLOR(IOLDCOL)
      RETURN
      END

      SUBROUTINE MGOLPOINTS(X,Y,NXY,STYLE,NSTYLE,LABELS,NLABEL,PRE)
      PARAMETER (MAXAVOID=1000, MAXPREF=7)
      INCLUDE 'mongo.par'
      REAL X(1), Y(1)
      INTEGER STYLE(1)
      REAL*8 CODE
      CHARACTER*(*) LABELS(1), PRE
      CHARACTER*50 PADLABEL, PRELABEL
      CHARACTER*3 ENDING
      CHARACTER BS
      REAL STRLOC(6,MAXAVOID), PTBOX(6), STBOX(6)
      INTEGER*2 PREFLOC(MAXPREF)
      LOGICAL BOXIT, LINEIT, DECORATE
      DATA PREFLOC /9,6,3,7,4,1,2/

      IF(NXY.LT.1.OR.NLABEL.LT.1) RETURN
      BS = CHAR(92)
      ENDING = BS//BS//'e'
      OLDEXP = EXPAND
      OLDANG = ANGLE
      IOLDCOL = ICOLOR
      LOCPRE = -1
      LOCPTY = 5
      IP1 = 1
      IF(PRE(1:1).EQ.' ') THEN
         IP2 = 0
      ELSE
* If preamble includes a bare digit, interpret it as an overriding justfication
         BOXIT = PRE(2:2).EQ.'B' .OR. PRE(2:2).EQ.'b'
         LINEIT = PRE(2:2).EQ.'L' .OR. PRE(2:2).EQ.'l'
         DECORATE = PRE(2:2).EQ.'D' .OR. PRE(2:2).EQ.'d'
         BOXIT = BOXIT .OR. DECORATE
         LINEIT = LINEIT .OR. DECORATE
         IP2 = MGOLENC(PRE)
         IF(PRE(1:1).GE.'0'.AND.PRE(1:1).LE.'9' .AND.
     $       (PRE(2:2).EQ.' ' .OR. BOXIT .OR. LINEIT)) THEN
            LOCPRE = ICHAR(PRE(1:1)) - ICHAR('0')
            IP1 = 3
         ELSE
            BOXIT = .FALSE.
            LINEIT = .FALSE.
         END IF
      END IF
      DO 10 J = 1,MIN(NLABEL,NXY)
          CALL MGORELOCATE(X(J),Y(J))
          IF(J.LE.NSTYLE) THEN
             CODE = STYLE(J)
             EXPAND = OLDEXP
             ANGLE = OLDANG
             CALL MGOSETCOLOR(IOLDCOL)
             CALL MGOPTDECODE(LOCPTY,ISTYLE,EXPO,ANG,ICOL,CODE)
* This was an error, I think 010126
C             LOCPTY = LOCPTY + 1
             IF(LOCPTY.LE.0) LOCPTY = 5
             IF(EXPO.GT.0) EXPAND = OLDEXP*EXPO
             IF(ANG.GT.0) ANGLE = ANG
             IF(ICOL.GT.0) CALL MGOSETCOLOR(ICOL)
          END IF

* Put the prefix onto the label
          LPRE = MGOLENC(LABELS(J))
          IF(IP2.ge.IP1) THEN
             LPRE = LPRE + (IP2-IP1+1)
             PRELABEL = PRE(IP1:IP2) // LABELS(J)
          ELSE
             PRELABEL = LABELS(J)
          END IF

* Where is the label supposed to be drawn?
          LOCNOW = LOCPRE
          IF(LOCPRE.LT.0 .AND. J.LE.NSTYLE) LOCNOW = LOCPTY

          DO 58 KK = 1,MAXPREF

* Note that I've allowed LOCNOW to be 0 (which is supposed to mean smart
* positioning) but it's not totally debugged yet...
*
* What I ought to have is some sort of metric which tells me how badly
* each LOC fails.  Then instead of falling back on LOC = 2 as a crash I
* could at least pick the best of the failures.
*
             IF(LOCNOW.GT.0) THEN
                LOC = LOCNOW
             ELSE
* Try out label locations in order of preference
                LOC = PREFLOC(KK)
             END IF
             IF(MOD(LOC,3).EQ.0) THEN
                PADLABEL = ' ' // PRELABEL(:LPRE) // ENDING
                L = LPRE + 4
             ELSE IF(MOD(LOC-1,3).EQ.0) THEN
                PADLABEL = PRELABEL(:LPRE) // ' ' //ENDING
                L = LPRE + 4
             ELSE
                PADLABEL = PRELABEL(:LPRE) //ENDING
                L = LPRE + 3
             END IF

             CS = COS(ANGLE*PI/180)
             SN = SIN(ANGLE*PI/180)
* How big is this particular label?
             CALL MGOGSTRLEN(L,PADLABEL,SLENGTH,SHEIGHT)

             DX = (MOD(LOC-1,3) - 2) * SLENGTH/2.
             DY = (((LOC-1))/3 - 2) * SHEIGHT/2.

             IF(LOCNOW.GT.0) GOTO 59

* Do some clever stuff to avoid other points and labels
             NOGO = 0
* How big are points?
             PX = PXDEF * EXPX * EXPAND
             PY = PYDEF * EXPY * EXPAND

* Here's where the string box will lie at this location
             STBOX(1) = XP + DX*CS - DY*SN
             STBOX(2) = YP + DX*SN + DY*CS
             STBOX(3) = STBOX(1) + SLENGTH*CS - SHEIGHT*SN
             STBOX(4) = STBOX(2) + SLENGTH*SN + SHEIGHT*CS
             STBOX(5) = CS
             STBOX(6) = SN

* Check all points except for self
             DO 56 I = 1,MIN(NLABEL,NXY)
                IF(I.EQ.J) GOTO 56
                XP1 = GX1 + (GX2-GX1)*(X(I)-X1)/(X2-X1)
                YP1 = GY1 + (GY2-GY1)*(Y(I)-Y1)/(Y2-Y1)
                PTBOX(1) = XP1 - PX
                PTBOX(2) = YP1 - PY
                PTBOX(3) = XP1 + PX
                PTBOX(4) = YP1 + PY
                PTBOX(5) = 1
                PTBOX(6) = 0
                NOGO = MGOBOXLAP(PTBOX,STBOX)+MGOBOXLAP(STBOX,PTBOX)
C                write(6,1451) I, J, loc, nogo, ptbox, stbox
C 1451           format('PT C',4i5,12f7.0)

                IF(NOGO.NE.0) GOTO 58

* Check all previous labels...
                IF(I.LT.J) NOGO = MGOBOXLAP(STRLOC(1,I),STBOX) + 
     $               MGOBOXLAP(STBOX, STRLOC(1,I))
                IF(NOGO.NE.0) GOTO 58
 56          CONTINUE

             GOTO 59

 58       CONTINUE
 59       CONTINUE

* Save the location of this string
          IF(LOCNOW.EQ.0 .AND. J.LE.MAXAVOID) THEN
             STRLOC(1,J) = STBOX(1)
             STRLOC(2,J) = STBOX(2)
             STRLOC(3,J) = STBOX(3)
             STRLOC(4,J) = STBOX(4)
             STRLOC(5,J) = STBOX(5)
             STRLOC(6,J) = STBOX(6)
          END IF

C             write(6,1455) j, x(j), y(j), loc, ptbox, stbox
C 1455        format(i5,2f7.1,i5,12f7.0)

          CALL MGOPUTLABEL(L,PADLABEL,LOC)

* Draw a little box around the label, and/or draw a little line segment
          if(boxit) then
             sl = slength + 0.5 * sheight
             sh = 1.16666 * sheight
             dx = (mod(loc-1,3) - 2) * 0.5 * sl
             dy = (((loc-1))/3 - 2) * 0.45 * sh
             call mgorelocate(x(j),y(j))
             call mgogrelocate(xp+dx*cs-dy*sn,yp+dx*sn+dy*cs)
             call mgogdraw(xp+sl*cs,yp+sl*sn)
             call mgogdraw(xp-sh*sn,yp+sh*cs)
             call mgogdraw(xp-sl*cs,yp-sl*sn)
             call mgogdraw(xp+sh*sn,yp-sh*cs)
          end if

          if(lineit) then
             dx = (mod(loc-1,3) - 1) * 0.5 * sheight
             dy = (((loc-1))/3 - 1) * 0.5 * sheight
             call mgorelocate(x(j),y(j))
             call mgogdraw(xp+dx*cs-dy*sn,yp+dx*sn+dy*cs)
          end if

10    CONTINUE
      EXPAND = OLDEXP
      ANGLE = OLDANG
      CALL MGOSETCOLOR(IOLDCOL)
      RETURN
      END

      SUBROUTINE MGOERRORBAR(LOCATION,X,Y,ERR,NXY)
      INCLUDE 'mongo.par'
C LOCATION = +1 - +4 for bars to X, Y, -X, -Y
C LOCATION = -1 - -4 for logarithmic bars to X, Y, -X, -Y
      REAL X(1), Y(1), ERR(1)
      IF(NXY.LT.1) RETURN
      SAVE = ANGLE
      IF(2*(LOCATION/2).EQ.LOCATION) THEN
          ANGLE = 0
      ELSE
          ANGLE = 90
      END IF
      DO 35 J = 1,NXY
      CALL MGORELOCATE(X(J),Y(J))
      IF(LOCATION.EQ.1) THEN
          XX = X(J) + ERR(J)
          YY = Y(J)
      ELSE IF(LOCATION.EQ.2) THEN
          XX = X(J)
          YY = Y(J) + ERR(J)
      ELSE IF(LOCATION.EQ.3) THEN
          XX = X(J) - ERR(J)
          YY = Y(J)
      ELSE IF(LOCATION.EQ.4) THEN
          XX = X(J)
          YY = Y(J) - ERR(J)
      ELSE IF(LOCATION.EQ.-1) THEN
          XX = alog10(amax1(1e-37,10.**X(J) + ERR(J)))
          YY = Y(J)
      ELSE IF(LOCATION.EQ.-2) THEN
          XX = X(J)
          YY = alog10(amax1(1e-37,10.**Y(J) + ERR(J)))
      ELSE IF(LOCATION.EQ.-3) THEN
          XX = alog10(amax1(1e-37,10.**X(J) - ERR(J)))
          YY = Y(J)
      ELSE IF(LOCATION.EQ.-4) THEN
          XX = X(J)
          YY = alog10(amax1(1e-37,10.**Y(J) - ERR(J)))
      END IF
      CALL MGODRAW(XX,YY)
      CALL MGOPOINT(2,0)
35    CONTINUE
      ANGLE = SAVE
      RETURN
      END

      SUBROUTINE MGOHISTOGRAM(X,Y,NXY)
      INCLUDE 'mongo.par'
      REAL X(2), Y(2)
      IF(NXY.LT.2) RETURN
      XAV = X(1) - .5*(X(2)-X(1))
      CALL MGORELOCATE(XAV,Y(1))
      DO 40 J = 2,NXY
          XAV = .5 * (X(J) + X(J-1))
          CALL MGODRAW(XAV,Y(J-1))
          CALL MGODRAW(XAV,Y(J))
40    CONTINUE
      XAV = X(NXY) + .5*(X(NXY)-X(NXY-1))
      CALL MGODRAW(XAV,Y(NXY))
      RETURN
      END

      SUBROUTINE MGOHATCH(X,Y,NXY,IHIST)
      INCLUDE 'mongo.par'
      REAL X(2), Y(2)
      IF(NXY.LT.2) RETURN
      NHIST = NINT(0.01*EXPAND*LX2)
      J1 = IHIST
      IF(IHIST.LT.0) THEN
          NHIST = -NHIST
          J1 = -IHIST
      END IF
      XAV = X(1) - .5*(X(2)-X(1))
      CALL MGORELOCATE(XAV,Y1)
      CALL MGODRAW(XAV,Y(1))
      I1 = NINT(XP)
      DO 40 J = 2,NXY
          XAV = .5 * (X(J) + X(J-1))
          CALL MGODRAW(XAV,Y(J-1))
          I2 = NINT(XP)
          J2 = NINT(YP)
          CALL MGODRAW(XAV,Y(J))
          CALL MGOHATCHER(I1,I2,J1,J2,NHIST)
          CALL MGORELOCATE(XAV,Y(J))
          I1 = I2
40    CONTINUE
      XAV = X(NXY) + .5*(X(NXY)-X(NXY-1))
      CALL MGODRAW(XAV,Y(NXY))
      I2 = NINT(XP)
      J2 = NINT(YP)
      CALL MGODRAW(XAV,Y1)
      CALL MGOHATCHER(I1,I2,J1,J2,NHIST)
      RETURN
      END

      SUBROUTINE MGOHATCH2(X,Y,Z,NXY,IHIST)
* Hatch between Y and Z if IHIST = 0
      INCLUDE 'mongo.par'
      REAL X(2), Y(2), Z(2)
      IF(NXY.LT.2) RETURN
      NHIST = NINT(0.01*EXPAND*LX2)
      XAV = X(1) - .5*(X(2)-X(1))
      CALL MGORELOCATE(XAV,Y1)
      CALL MGODRAW(XAV,Y(1))
      I1 = NINT(XP)
      DO 40 J = 2,NXY
          XAV = .5 * (X(J) + X(J-1))
          CALL MGODRAW(XAV,Y(J-1))
          I2 = NINT(XP)
          J2 = NINT(YP)
          CALL MGODRAW(XAV,Y(J))
          J1 = NINT(GY1+(GY2-GY1)/(Y2-Y1)*(Z(J-1)-Y1))
          NHIST = IABS(NHIST)
          IF(J1.GT.J2) NHIST = -IABS(NHIST)
          CALL MGOHATCHER(I1,I2,J1,J2,NHIST)
          CALL MGORELOCATE(XAV,Y(J))
          I1 = I2
40    CONTINUE
      XAV = X(NXY) + .5*(X(NXY)-X(NXY-1))
      CALL MGODRAW(XAV,Y(NXY))
      I2 = NINT(XP)
      J2 = NINT(YP)
      CALL MGODRAW(XAV,Y1)
      J1 = NINT(GY1+(GY2-GY1)/(Y2-Y1)*(Z(NXY)-Y1))
      NHIST = IABS(NHIST)
      IF(J1.GT.J2) NHIST = -IABS(NHIST)
      CALL MGOHATCHER(I1,I2,J1,J2,NHIST)
      RETURN
      END

      SUBROUTINE MGOHATCHER(II1,II2,JJ1,JJ2,IHF)
C Hatch the area delimited by I1,I2; J1,J2 every IHF in device coords
C IHF < 0 hatch at -45 deg, if IHF > 0 hatch at 45 deg.
      IF(IHF.EQ.0) IHF = 1
      IF(II2.LT.II1) THEN
          I1 = II2
          I2 = II1
      ELSE
          I1 = II1
          I2 = II2
      END IF
      IF(JJ2.LT.JJ1) THEN
          J1 = JJ2
          J2 = JJ1
      ELSE
          J1 = JJ1
          J2 = JJ2
      END IF
      J0 = MOD(I1,IABS(IHF))
      IF(IHF.GT.0) THEN
          K1 = MGOMULT(J1-(I2-I1)-J0,IHF) + J0
          K2 = J2
      ELSE
          K1 = MGOMULT(J1+J0,-IHF) - J0
          K2 = J2 + (I2 - I1)
      END IF
      DO 10 K = K1,K2,IABS(IHF)
         L1 = I1
         L2 = I2
         M1 = K
         IF(IHF.GT.0) THEN
            M2 = K + I2 - I1
         ELSE
            M2 = K - I2 + I1
         END IF
         IF(M1.LT.J1) THEN
            L1 = I1 + J1 - M1
            M1 = J1
         ELSE IF(M1.GT.J2) THEN
            L1 = I1 + M1 - J2
            M1 = J2
         END IF
         IF(M2.LT.J1) THEN
            L2 = I2 + M2 - J1
            M2 = J1
         ELSE IF(M2.GT.J2) THEN
            L2 = I2 + J2 - M2
            M2 = J2
         ELSE
         END IF
         CALL MGOGRELOCATE(FLOAT(L1),FLOAT(M1))
         CALL MGOGDRAW(FLOAT(L2),FLOAT(M2))
10    CONTINUE
      RETURN
      END

      FUNCTION MGOMULT(I,J)
* Return the first multiple of J that is larger than I
      IF(I.GE.0) THEN
          MGOMULT = J * ((I+J-1)/J)
      ELSE
          MGOMULT = J * (-(-I+J)/J+1)
      END IF
      RETURN
      END

      SUBROUTINE MGOVFIELD(X,Y,R,PHI,NXY)
      CALL MGOVFPOLAR(X,Y,R,PHI,NXY,0.0)
      RETURN
      END

      SUBROUTINE MGOVFPOLAR(X,Y,R,PHI,NXY,VSCALE)
      INCLUDE 'mongo.par'
C Makes a vector field with vector (R,PHI) from (X,Y).
C PHI is in degrees.
C Magnitude is EXPAND * 1/30 range in x / mean length
      REAL X(1), Y(1), R(1), PHI(1)
      IF(NXY.LT.1) RETURN
      DR = PI / 180.
      IF(VSCALE.LE.0) THEN
         AVE = 0
         DO 10 I = 1,NXY
            AVE = AVE + R(I)
 10      CONTINUE
         AVE = AVE / NXY
         IF(AVE.NE.0) THEN
            FACTOR = EXPAND * (GX2-GX1)/30 / AVE
         ELSE
            FACTOR = 0
         END IF
      ELSE
         FACTOR = VSCALE * (GX2-GX1) / (X2-X1)
      END IF
      DO 20 J = 1,NXY
          PSI1 = PHI(J) - 180 + 20
          PSI2 = PHI(J) - 180 - 20
          ARROW = FACTOR * R(J)
          HEAD = AMAX1(AMIN1(ARROW/3.,(GX2-GX1)/50),-(GX2-GX1)/50)
          CALL MGORELOCATE(X(J),Y(J))
          CALL MGOGDRAW(XP+ARROW*COS(DR*PHI(J)),YP+ARROW*SIN(DR*PHI(J)))
          XQ = XP
          YQ = YP
          CALL MGOGDRAW(XP+HEAD*COS(DR*PSI1),YP+HEAD*SIN(DR*PSI1))
          CALL MGOGRELOCATE(XQ,YQ)
          CALL MGOGDRAW(XP+HEAD*COS(DR*PSI2),YP+HEAD*SIN(DR*PSI2))
20    CONTINUE
      RETURN
      END

      SUBROUTINE MGOVFCART(X,Y,DX,DY,NXY,VSCALE)
      INCLUDE 'mongo.par'
C Makes a vector field with vector (DX,DY) from (X,Y).
C Magnitude is EXPAND * 1/30 range in x / mean length
      REAL X(1), Y(1), DX(1), DY(1)
      IF(NXY.LT.1) RETURN
      DR = PI / 180.
      IF(VSCALE.LE.0) THEN
         AVE = 0
         DO 10 I = 1,NXY
            R = DX(I)*DX(I) + DY(I)*DY(I)
            AVE = AVE + R
 10      CONTINUE
         AVE = SQRT(AVE / NXY)
         IF(AVE.NE.0) THEN
            FACTOR = EXPAND * (GX2-GX1)/30 / AVE
         ELSE
            FACTOR = 0
         END IF
      ELSE
         FACTOR = VSCALE * (GX2-GX1) / (X2-X1)
      END IF
      DO 20 J = 1,NXY
          R = SQRT(DX(J)*DX(J) + DY(J)*DY(J))
          IF(R.GT.0) PHI = ATAN2(DY(J),DX(J)) / DR
          PSI1 = PHI - 180 + 20
          PSI2 = PHI - 180 - 20
          ARROW = FACTOR * R
          HEAD = AMIN1(ARROW/3.,(GX2-GX1)/50)
          CALL MGORELOCATE(X(J),Y(J))
          CALL MGOGDRAW(XP+ARROW*COS(DR*PHI),YP+ARROW*SIN(DR*PHI))
          XQ = XP
          YQ = YP
          CALL MGOGDRAW(XP+HEAD*COS(DR*PSI1),YP+HEAD*SIN(DR*PSI1))
          CALL MGOGRELOCATE(XQ,YQ)
          CALL MGOGDRAW(XP+HEAD*COS(DR*PSI2),YP+HEAD*SIN(DR*PSI2))
20    CONTINUE
      RETURN
      END

      SUBROUTINE MGOVFSEG(X,Y,U,V,NXY,VSCALE)
      INCLUDE 'mongo.par'
C Makes a field of segments between (x,y) and (u,v)
      REAL X(1), Y(1), U(1), V(1)
      IF(NXY.LT.1) RETURN
      DO 20 J = 1,NXY
          CALL MGORELOCATE(X(J),Y(J))
          CALL MGODRAW(U(J),V(J))
20    CONTINUE
      RETURN
      END

      SUBROUTINE MGOLOGARITHM(ARRAY,NXY)
      REAL ARRAY(1)
      DO 10 J = 1,NXY
          IF(ARRAY(J).GT.0) THEN
              ARRAY(J) = ALOG10(ARRAY(J))
          ELSE
              ARRAY(J) = -50
          END IF
10    CONTINUE
      RETURN
      END

      SUBROUTINE MGOMINIMAX(XMIN,XMAX,YMIN,YMAX,X,Y,NXY)
      REAL X(1), Y(1)
      IF(NXY.LT.1) THEN
          XMIN = 0
          XMAX = 1
          YMIN = 0
          YMAX = 1
          RETURN
      END IF
      XMIN = X(1)
      XMAX = X(1)
      YMIN = Y(1)
      YMAX = Y(1)
      DO 10 J = 2,NXY
          XMIN = AMIN1(XMIN,X(J))
          XMAX = AMAX1(XMAX,X(J))
          YMIN = AMIN1(YMIN,Y(J))
          YMAX = AMAX1(YMAX,Y(J))
10    CONTINUE
      XDIFF = XMAX - XMIN
C      IF(XDIFF.EQ.0) XDIFF = XMIN
      IF(XDIFF.EQ.0) XDIFF = 1
      YDIFF = YMAX - YMIN
C      IF(YDIFF.EQ.0) YDIFF = YMIN
      IF(YDIFF.EQ.0) YDIFF = 1
      XMIN = XMIN - .05*XDIFF
      XMAX = XMAX + .05*XDIFF
      YMIN = YMIN - .05*YDIFF
      YMAX = YMAX + .05*YDIFF
      RETURN
      END

* Return 1/0 if two boxes overlap
      function mgoboxlap(box1,box2)
* Box coords are (x1,y1,x2,y2,cos,sin)
      real box1(6), box2(6)
      real p(2,4), x(4), y(4)
      logical ok

      mgoboxlap = 0

* Translate origin to first corner of first box and rotate to zero angle
      cs = box1(5)
      sn = box1(6)
      x2 =  (box1(3)-box1(1))*cs + (box1(4)-box1(2))*sn
      y2 = -(box1(3)-box1(1))*sn + (box1(4)-box1(2))*cs

* Regenerate all four vertices of second box (with translation)
      c2 = box2(5)
      s2 = box2(6)
      p(1,1) = box2(1)-box1(1)
      p(2,1) = box2(2)-box1(2)
      p(1,3) = box2(3)-box1(1)
      p(2,3) = box2(4)-box1(2)
      e1 =  p(1,3)*c2 + p(2,3)*s2
      e2 = -p(1,3)*s2 + p(2,3)*c2
      p(1,2) = p(1,1) + e1*c2
      p(2,2) = p(2,1) + e1*s2
      p(1,4) = p(1,1) - e2*s2
      p(2,4) = p(2,1) + e2*c2

* Rotate and look for crossing
      do 10 i = 1,4
         x(i) =  p(1,i)*cs + p(2,i)*sn
         y(i) = -p(1,i)*sn + p(2,i)*cs
 10   continue

* Does second box intersect (or include) unity box?
      call mgocross(x(1),y(1),x(2),y(2),0.0,x2,0.0,y2,xc,yc,xd,yd,ok)
      if(ok) goto 999
      call mgocross(x(2),y(2),x(3),y(3),0.0,x2,0.0,y2,xc,yc,xd,yd,ok)
      if(ok) goto 999
      call mgocross(x(3),y(3),x(4),y(4),0.0,x2,0.0,y2,xc,yc,xd,yd,ok)
      if(ok) goto 999
      call mgocross(x(1),y(1),x(4),y(4),0.0,x2,0.0,y2,xc,yc,xd,yd,ok)
      if(ok) goto 999

      return
 999  mgoboxlap = 1
      return
      end
