CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE MGOEXECUTE(COMMAND,REST,ERROR,DATA)
      INCLUDE 'mongo.par'
      INCLUDE 'arrays.par'
      INCLUDE 'luns.par'
      INCLUDE 'files.par'
      INCLUDE 'vocab.par'
      CHARACTER*(*) COMMAND, REST
      CHARACTER*32 PAR, MACNAME
      CHARACTER*128 INFILE, DATAFILE, FILENAME
      REAL ARG(20)
      LOGICAL ERROR, TERMIDLE
      DATA TERMIDLE /.FALSE./

      ERROR = .FALSE.

      IF(IFSKIP.GT.0) THEN
         IFSKIP = 0
         GOTO 999
      END IF

      IF(NBREAK.GT.0) NBREAK = 0

      IF(COMMAND.EQ.'angle') THEN
          CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
          CALL MGOPARSE(REST(NEXTPAR:),PAR,LENPAR,NEXTPAR)
          IF(LENPAR.GT.0) THEN
              CALL MGOARGUMENTS(4,REST,ARG,ERROR)
              IF(ERROR) GOTO 999
              CALL MGOSETSLOPE(ARG(1),ARG(2),ARG(3),ARG(4))
          ELSE
              CALL MGOARGUMENTS(1,REST,ARG,ERROR)
              IF(ERROR) GOTO 999
              CALL MGOSETANGLE(ARG(1))
          END IF

      ELSE IF(COMMAND.EQ.'axis') THEN
          CALL MGOARGUMENTS(10,REST,ARG,ERROR)
          IF(ERROR) GOTO 999
          ILABEL = NINT(ARG(9))
          ICLOCK = NINT(ARG(10))
C          CALL MGOTSELECT
          CALL MGOAXIS(ARG(1),ARG(2),ARG(3),ARG(4),ARG(5),ARG(6),
     1			ARG(7),ARG(8),ILABEL,ICLOCK)

      ELSE IF(COMMAND.EQ.'box') THEN
          CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
          IF(LENPAR.EQ.0) THEN
              LABELX = 1
              LABELY = 2
          ELSE
              CALL MGOARGUMENTS(2,REST,ARG,ERROR)
              IF(ERROR) GOTO 999
              LABELX = NINT(ARG(1))
              LABELY = NINT(ARG(2))
          END IF
C          CALL MGOTSELECT
          CALL MGOBOX(LABELX,LABELY)

      ELSE IF(COMMAND.EQ.'break') THEN
          CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
          IF(LENPAR.GT.0) THEN
             CALL MGOARGUMENTS(1,REST,ARG,ERROR)
             IF(ERROR) GOTO 999
          ELSE
             ARG(1) = 1
          END IF
          IF(ARG(1).GT.-1E-4) NBREAK = NINT(ARG(1))
          IF(ARG(1).LT.-1E-4) NBREAK = 1000

      ELSE IF(COMMAND.EQ.'color') THEN
          CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
          CALL MGOPARSE(REST(NEXTPAR:),PAR,LENPAR,NEXTPAR)
          IF(LENPAR.GT.0) THEN
              CALL MGOARGUMENTS(4,REST,ARG,ERROR)
          ELSE
              CALL MGOARGUMENTS(1,REST,ARG,ERROR)
           end if
           IF(ERROR) GOTO 999
           IC = NINT(ARG(1))
           IF((IC.LT.0 .OR. IC.GT.MAXPALETTE-1).and.ic.ne.-1) THEN
              WRITE(6,6239) MAXPALETTE-1
 6239         FORMAT('Palette entries must range between 0 and',I3)
              GOTO 999
           END IF
           IF(LENPAR.GT.0) THEN
              CALL MGOSETPALETTE(IC,ARG(2),ARG(3),ARG(4))
           ELSE
              CALL MGOSETCOLOR(IC)
           END IF

      ELSE IF(COMMAND.EQ.'connect') THEN
C          CALL MGOTSELECT
         CALL MGOTWOARRAY(REST, I1, I2)
         CALL MGOCONNECT(DATARRAY(DATAPTR(I1)), DATARRAY(DATAPTR(I2)),
     $        MIN(DATASIZE(I1),DATASIZE(I2)))

      ELSE IF(COMMAND.EQ.'contour') THEN
          IF(.NOT.INTERNAL) THEN
              call MGOERR('Contour uses data from MONGO subroutine')
              GOTO 999
          END IF
          CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
          IF(LENPAR.EQ.0) THEN
              call MGOERR('Contour n level1 ... leveln')
              GOTO 999
          END IF
          CALL MGOARGUMENTS(1,PAR,ARG,ERROR)
          IF(ERROR) GOTO 999
          NLEVEL = NINT(ARG(1))
          CALL MGOARGUMENTS(NLEVEL,REST(NEXTPAR:),ARG,ERROR)
          IF(ERROR) GOTO 999
C          CALL MGOTSELECT
          CALL MGOCONTOUR(DATA,NROW,NCOL,ARG,NLEVEL)

      ELSE IF(COMMAND.EQ.'cursor') THEN
          CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
          IF(LENPAR.EQ.0) THEN
              IREAD = 1
C              CALL MGOTSELECT
              CALL MGOCURSOR(CX,CY,IREAD)
              WRITE(REST,'(1P2G12.4)') CX, CY
          ELSE
              CALL MGOARGUMENTS(2,REST,ARG,ERROR)
              IF(ERROR) GOTO 999
              IREAD = 0
              CALL MGOCURSOR(ARG(1),ARG(2),IREAD)
          END IF

      ELSE IF(COMMAND.EQ.'data') THEN
          CALL MGOPARSE(REST,DATAFILE,LENPAR,NEXTPAR)
          IF(LENPAR.EQ.0) THEN
              CALL MGOINTERNALDATA
          ELSE
              CALL MGOOPENFILE(DATAFILE,MXARRAY,ERROR)
          END IF

      ELSE IF(COMMAND.EQ.'delete') THEN
          CALL MGODELETE(REST,ERROR)

      ELSE IF(COMMAND.EQ.'device') THEN
          CALL MGOARGUMENTS(1,REST,ARG,ERROR)
          IF(ERROR) GOTO 999
          N = NINT(ARG(1))
          CALL MGOSETUP(N)
          IF(N.LT.0) THEN
              TERMIDLE = .FALSE.
          ELSE
              TERMIDLE = .TRUE.
          END IF

      ELSE IF(COMMAND.EQ.'dot') THEN
C          CALL MGOTSELECT
          CALL MGODOT

      ELSE IF(COMMAND.EQ.'draw') THEN
          CALL MGOARGUMENTS(2,REST,ARG,ERROR)
          IF(ERROR) GOTO 999
C          CALL MGOTSELECT
          CALL MGODRAW(ARG(1),ARG(2))

      ELSE IF(COMMAND.EQ.'ecolumn') THEN
          CALL MGOARGUMENTS(1,REST,ARG,ERROR)
          IF(ERROR) GOTO 999
          NC = NINT(ARG(1))
C          CALL MGOTSELECT
          CALL MGOREADCOL(NC,MAXE,
     $         DATARRAY(DATAPTR(ICHAR('E')-ICHAR('A')+1)),
     $         NAE,ERROR,DATA)

      ELSE IF(COMMAND.EQ.'end') THEN
         call exit(0)
      ELSE IF(COMMAND.EQ.'exit') THEN
         call exit(0)
      ELSE IF(COMMAND.EQ.'quit') THEN
         call exit(0)
      ELSE IF(COMMAND.EQ.'stop') THEN
         call exit(0)

      ELSE IF(COMMAND.EQ.'erase') THEN
C          CALL MGOTSELECT
          CALL MGOERASE

      ELSE IF(COMMAND.EQ.'errorbar') THEN
          CALL MGOARGUMENTS(1,REST,ARG,ERROR)
          IF(ERROR) GOTO 999
          LOCATION = NINT(ARG(1))
C          CALL MGOTSELECT
          CALL MGOERRORBAR(LOCATION,
     $         DATARRAY(DATAPTR(ICHAR('X')-ICHAR('A')+1)),
     $         DATARRAY(DATAPTR(ICHAR('Y')-ICHAR('A')+1)),
     $         DATARRAY(DATAPTR(ICHAR('E')-ICHAR('A')+1)),
     $         MIN(NAX,NAY,NAE))

      ELSE IF(COMMAND.EQ.'execute') THEN
C "execute" is the command only if no arguments and then is a NOOP

      ELSE IF(COMMAND.EQ.'expand') THEN
          CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
          CALL MGOPARSE(REST(NEXTPAR:),PAR,LENPAR,NEXTPAR)
          IF(LENPAR.GT.0) THEN
              CALL MGOARGUMENTS(2,REST,ARG,ERROR)
              IF(ERROR) GOTO 999
              CALL MGOSETDIFFEXP(ARG(1), ARG(2))
          ELSE
              CALL MGOARGUMENTS(1,REST,ARG,ERROR)
              IF(ERROR) GOTO 999
              CALL MGOSETEXPAND(ARG(1))
          END IF

      ELSE IF(COMMAND.EQ.'fill') THEN
          CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
          CALL MGOPARSE(REST(NEXTPAR:),PAR,LENPAR,NEXTPAR)
          IRELOC = 0
          IF(LENPAR.GT.0) THEN
              CALL MGOARGUMENTS(2,REST,ARG,ERROR)
              IF(ERROR) GOTO 999
              IRELOC = NINT(ARG(2))
          ELSE
              CALL MGOARGUMENTS(1,REST,ARG,ERROR)
              IF(ERROR) GOTO 999
          END IF
          CALL MGOSETFILL(NINT(ARG(1)), IRELOC)

      ELSE IF(COMMAND.EQ.'format') THEN
          CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
          IF(LENPAR.GT.0) THEN
              CALL MGOSETFORMAT(REST)
          ELSE
              CALL MGOSETFORMAT('*')
          END IF

      ELSE IF(COMMAND.EQ.'grid') THEN
          CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
          IF(LENPAR.GT.0) THEN
              CALL MGOARGUMENTS(1,REST,ARG,ERROR)
              IF(ERROR) GOTO 999
              IFREQ = NINT(ARG(1))
C              CALL MGOTSELECT
              CALL MGOGRID(IFREQ)
          ELSE
C              CALL MGOTSELECT
              CALL MGODEFGRID
          END IF

      ELSE IF(COMMAND.EQ.'halftone') THEN
          IF(.NOT.INTERNAL) THEN
              call MGOERR('Halftone uses data from MONGO subroutine')
              GOTO 999
          END IF
          CALL MGOARGUMENTS(2,REST,ARG,ERROR)
          IF(ERROR) GOTO 999
          Z1 = ARG(1)
          Z2 = ARG(2)
          CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
          NEXTPOS = NEXTPAR - 1
          CALL MGOPARSE(REST(NEXTPAR:),PAR,LENPAR,NEXTPAR)
          CALL MGOPARSE(REST(NEXTPOS+NEXTPAR:),PAR,LENPAR,NEXTNEXT)
          IF(LENPAR.GT.0) THEN
C              CALL MGOARGUMENTS(2,PAR,ARG,ERROR)
              CALL MGOARGUMENTS(2,REST(NEXTPOS+NEXTPAR:),ARG,ERROR)
              IF(ERROR) GOTO 999
              CONTRAST = ARG(1)
           ELSE
              CONTRAST = 100
              ARG(2) = 1
          END IF
C          CALL MGOTSELECT
          IALG = NINT(ARG(2))
          CALL MGOHALFTONE(DATA,NROW,NCOL,Z1,Z2,CONTRAST,IALG)

      ELSE IF(COMMAND.EQ.'hardcopy') THEN
          CALL MGOPRNTPLOT(NVECTORS)
          WRITE(FILENAME,'(I6,A)') NVECTORS, ' vectors plotted.'
          CALL MGOUT(FILENAME)
          CALL MGOPRNTINIT

      ELSE IF(COMMAND.EQ.'help') THEN
          CALL MGOHELP(REST,ERROR)

      ELSE IF(COMMAND.EQ.'histogram') THEN
          CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
          IF(LENPAR.GT.0) THEN
              CALL MGOARGUMENTS(1,REST,ARG,ERROR)
              IF(ERROR) GOTO 999
              IHIST = NINT(ARG(1))
C              CALL MGOTSELECT
              CALL MGOPARSE(REST(NEXTPAR:),PAR,LENPAR,NEXTPAR)
              IF(LENPAR.GT.0) THEN
                   CALL MGOHATCH2(
     $                DATARRAY(DATAPTR(ICHAR('X')-ICHAR('A')+1)),
     $                DATARRAY(DATAPTR(ICHAR('Y')-ICHAR('A')+1)),
     $                DATARRAY(DATAPTR(ICHAR('E')-ICHAR('A')+1)),
     $                MIN(NAX,NAY,NAE),IHIST)
              ELSE
                   CALL MGOHATCH(
     $                DATARRAY(DATAPTR(ICHAR('X')-ICHAR('A')+1)),
     $                DATARRAY(DATAPTR(ICHAR('Y')-ICHAR('A')+1)),
     $                MIN(NAX,NAY),IHIST)
              END IF
          ELSE
C              CALL MGOTSELECT
              CALL MGOHISTOGRAM(
     $            DATARRAY(DATAPTR(ICHAR('X')-ICHAR('A')+1)),
     $            DATARRAY(DATAPTR(ICHAR('Y')-ICHAR('A')+1)),
     $            MIN(NAX,NAY))
          END IF

      ELSE IF(COMMAND.EQ.'id') THEN
C          CALL MGOTSELECT
          CALL MGOPLOTID(INFILE,DATAFILE)

      ELSE IF(COMMAND.EQ.'if') THEN
          CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
          IF(LENPAR.GT.0) THEN
             CALL MGOPARSE(REST(NEXTPAR:),PAR,LENPAR,NEXTPAR)
             IF(LENPAR.GT.0) THEN
                CALL MGOARGUMENTS(2,REST,ARG,ERROR)
                IF(ERROR) GOTO 999
                IF(ABS(ARG(1)-ARG(2)).GT.1E-5) IFSKIP = 1
             ELSE
                CALL MGOARGUMENTS(1,REST,ARG,ERROR)
                IF(ABS(ARG(1)).LT.1E-5) IFSKIP = 1
             END IF
          END IF

      ELSE IF(COMMAND.EQ.'info') THEN
          CALL MGOCOUNTOKEN(REST,NTOK)
          IF(NTOK.EQ.0) THEN
             IREAD = 2
             CALL MGOCURSOR(CX,CY,IREAD)
          ELSE
             NTOK = MAX(2,NTOK)
             CALL MGOARGUMENTS(NTOK,REST,ARG,ERROR)
             IF(ERROR) GOTO 999
             ITELLME = 1
             IF(NTOK.GE.3) ITELLME = NINT(ARG(3))
             CALL MGOINFO(ARG(1),ARG(2),ITELLME)
          END IF

      ELSE IF(COMMAND.EQ.'input') THEN
          CALL MGOPARSE(REST,INFILE,LENPAR,NEXTPAR)
          IF(LENPAR.EQ.0) THEN
              call MGOERR('Input "filename"')
              ERROR = .TRUE.
              GOTO 999
          END IF
          CALL MGOREADINPUT(INFILE,ERROR,DATA)

      ELSE IF(COMMAND.EQ.'label') THEN
          CALL MGOLABEL(MGOLENC(REST),REST)

      ELSE IF(COMMAND.EQ.'lcolumn') THEN
          CALL MGOARGUMENTS(1,REST,ARG,ERROR)
          IF(ERROR) GOTO 999
          NC = NINT(ARG(1))
          CALL MGOREADLABEL(NC,AUTOLABEL,NAL,ERROR,DATA)

      ELSE IF(COMMAND.EQ.'limits') THEN
          CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
          IF(LENPAR.EQ.0) THEN
              CALL MGOMINIMAX(ARG(1),ARG(2),ARG(3),ARG(4),
     $            DATARRAY(DATAPTR(ICHAR('X')-ICHAR('A')+1)),
     $            DATARRAY(DATAPTR(ICHAR('Y')-ICHAR('A')+1)),
     $            MIN(NAX,NAY))
          ELSE
              CALL MGOARGUMENTS(4,REST,ARG,ERROR)
              IF(ERROR) GOTO 999
          END IF
          CALL MGOSETLIM(ARG(1),ARG(3),ARG(2),ARG(4))

      ELSE IF(COMMAND.EQ.'lines') THEN
          CALL MGOARGUMENTS(2,REST,ARG,ERROR)
          IF(ERROR) GOTO 999
          L1 = NINT(ARG(1))
          L2 = NINT(ARG(2))
          CALL MGOLINES(L1,L2)

      ELSE IF(COMMAND.EQ.'list') THEN
          CALL MGOLIST(REST,ERROR)

      ELSE IF(COMMAND.EQ.'location') THEN
          CALL MGOARGUMENTS(4,REST,ARG,ERROR)
          IF(ERROR) GOTO 999
          CALL MGOSETLOC(ARG(1),ARG(3),ARG(2),ARG(4))

      ELSE IF(COMMAND.EQ.'lpoints') THEN
          L = MGOLENC(REST)
          N = MIN(NAX,NAY)
          CALL MGOLPOINTS(
     $         DATARRAY(DATAPTR(ICHAR('X')-ICHAR('A')+1)),
     $         DATARRAY(DATAPTR(ICHAR('Y')-ICHAR('A')+1)),N,
     $         DATARRAY(DATAPTR(ICHAR('P')-ICHAR('A')+1)),
     $         NSTYLE,
     $         AUTOLABEL,NAL,REST(:L))

      ELSE IF(COMMAND.EQ.'ltype') THEN
          CALL MGOARGUMENTS(1,REST,ARG,ERROR)
          IF(ERROR) GOTO 999
          ILTYPE = NINT(ARG(1))
C          CALL MGOTSELECT
          CALL MGOSETLTYPE(ILTYPE)

      ELSE IF(COMMAND.EQ.'lweight') THEN
          CALL MGOARGUMENTS(1,REST,ARG,ERROR)
          IF(ERROR) GOTO 999
          ILTYPE = NINT(ARG(1))
          CALL MGOSETLWEIGHT(ILTYPE)

      ELSE IF(COMMAND.EQ.'page') THEN
          CALL MGOARGUMENTS(1,REST,ARG,ERROR)
          IF(ERROR) GOTO 999
          IPAGE = NINT(ARG(1))
          CALL MGOPAGE(IPAGE)

      ELSE IF(COMMAND.EQ.'pcolumn') THEN
C Args: 1 = style, 2 = expansion, 3 = color, 4 = angle
         CALL MGOCOUNTOKEN(REST,NTOK)
         IF(NTOK.GT.0) THEN
            CALL MGOARGUMENTS(NTOK,REST,ARG,ERROR)
            IF(ERROR) GOTO 999
            IC1 = NINT(ARG(1))
            IC2 = 0
            IC3 = 0
            IC4 = 0
            IF(NTOK.GE.2) IC2 = NINT(ARG(2))
            IF(NTOK.GE.3) IC3 = NINT(ARG(3))
            IF(NTOK.GE.4) IC4 = NINT(ARG(4))
            CALL MGOREADPTYPE(IC1,IC2,IC3,IC4,
     $         MAXP,DATARRAY(DATAPTR(ICHAR('P')-ICHAR('A')+1)),
     $         NAP,ERROR,DATA)

         END IF
         NSTYLE = NAP

      ELSE IF(COMMAND.EQ.'physical') THEN
          CALL MGOARGUMENTS(4,REST,ARG,ERROR)
          IF(ERROR) GOTO 999
          CALL MGOSETPHYSICAL(ARG(1),ARG(3),ARG(2),ARG(4))

      ELSE IF(COMMAND.EQ.'playback') THEN
          CALL MGOPLAYBACK(REST,ERROR,DATA)

      ELSE IF(COMMAND.EQ.'points') THEN
C          CALL MGOTSELECT
         CALL MGOTWOARRAY(REST, I1, I2)
         CALL MGOPOINTS(
     $        DATARRAY(DATAPTR(ICHAR('P')-ICHAR('A')+1)),NSTYLE,
     $        DATARRAY(DATAPTR(I1)), DATARRAY(DATAPTR(I2)),
     $        MIN(DATASIZE(I1),DATASIZE(I2)))

      ELSE IF(COMMAND.EQ.'poly') THEN
         CALL MGOCOUNTOKEN(REST,NTOK)
         NTOK = MAX(1,NTOK)
         CALL MGOARGUMENTS(NTOK,REST,ARG,ERROR)
         IF(ERROR) GOTO 999
         IORDER = NINT(ARG(1))
         IPLOTIT = 11
         IEXCLUDE = 0
         NPTS = MIN(NAX,NAY)
         IF(NTOK.GE.2) IPLOTIT = NINT(ARG(2))
         IF(NTOK.GE.3) THEN
            IEXCLUDE = NINT(ARG(3))
            NPTS = MIN(NPTS,NAE)
         END IF
         CALL MGOPLOTPOLY(
     $        DATARRAY(DATAPTR(ICHAR('X')-ICHAR('A')+1)),
     $        DATARRAY(DATAPTR(ICHAR('Y')-ICHAR('A')+1)),
     $        DATARRAY(DATAPTR(ICHAR('E')-ICHAR('A')+1)),
     $        NPTS,IORDER,IPLOTIT,IEXCLUDE)

      ELSE IF(COMMAND.EQ.'printer') THEN
          CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
          IF(LENPAR.GT.0) THEN
              CALL MGOARGUMENTS(1,REST,ARG,ERROR)
              IF(NINT(ARG(1)).LE.0) THEN
                  call MGOERR('Positive arguments only')
                  ERROR = .TRUE.
              END IF
              LASTPRNT = -NINT(ARG(1))
              IF(ERROR) GOTO 999
              CALL MGOPARSE(REST(NEXTPAR:),PAR,LENPAR,NEXTPOS)
              IF(LENPAR.GT.0) THEN
                   RASTERCMD = REST(NEXTPAR:)
              ELSE
                   RASTERCMD = ' '
              END IF
          END IF
          CALL MGOSETUP(LASTPRNT)
          CALL MGOPRNTINIT
          TERMIDLE = .FALSE.

      ELSE IF(COMMAND.EQ.'ptype') THEN
          CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
          CALL MGOPARSE(REST(NEXTPAR:),PAR,LENPAR,NEXTPAR)
          IF(LENPAR.GT.0) THEN
              CALL MGOARGUMENTS(2,REST,ARG,ERROR)
              IF(ERROR) GOTO 999
              P = ARG(1) * 10 + ARG(2)
          ELSE
              CALL MGOARGUMENTS(1,REST,ARG,ERROR)
              IF(ERROR) GOTO 999
              P = ARG(1)
          END IF
          CALL MGOSETPTYPE(P)
          NSTYLE = 0

      ELSE IF(COMMAND.EQ.'putlabel') THEN
          CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
          CALL MGOARGUMENTS(1,PAR,ARG,ERROR)
          IF(ERROR) GOTO 999
          LOC = NINT(ARG(1))
          IF(NEXTPAR.LE.LEN(REST)) THEN
C              CALL MGOTSELECT
              CALL MGOPUTLABEL(MGOLENC(REST(NEXTPAR:)),
     1					REST(NEXTPAR:),LOC)
          END IF

      ELSE IF(COMMAND.EQ.'relocate') THEN
          CALL MGOARGUMENTS(2,REST,ARG,ERROR)
          IF(ERROR) GOTO 999
          CALL MGORELOCATE(ARG(1),ARG(2))

      ELSE IF(COMMAND.EQ.'reset') THEN
          CALL MGORESET

      ELSE IF(COMMAND.EQ.'set') THEN
          CALL MGOSETUVAR(REST,ERROR)

      ELSE IF(COMMAND.EQ.'show') THEN
          CALL MGOSHOW(REST,ERROR)

      ELSE IF(COMMAND.EQ.'spline') THEN
         CALL MGOTWOARRAY(REST, I1, I2)
         CALL MGOSPLINE(DATARRAY(DATAPTR(I1)), DATARRAY(DATAPTR(I2)),
     $        MIN(DATASIZE(I1),DATASIZE(I2)))

      ELSE IF(COMMAND.EQ.'terminal') THEN
          CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
          IF(LENPAR.GT.0) THEN
              CALL MGOARGUMENTS(1,REST,ARG,ERROR)
              IF(NINT(ARG(1)).LE.0) THEN
                  call MGOERR('Positive arguments only')
                  ERROR = .TRUE.
              END IF
              LASTTERM = NINT(ARG(1))
              IF(ERROR) GOTO 999
              CALL MGOPARSE(REST(NEXTPAR:),PAR,LENPAR,NEXTPAR)
              IF(LENPAR.GT.0) THEN
                  CALL MGOTERMNAME(PAR,ERROR)
              END IF
          END IF
C          CALL MGOTSELECT
          CALL MGOSETUP(LASTTERM)
          TERMIDLE = .TRUE.

      ELSE IF(COMMAND.EQ.'ticksize') THEN
          CALL MGOARGUMENTS(4,REST,ARG,ERROR)
          IF(ERROR) GOTO 999
          CALL MGOTICKSIZE(ARG(1),ARG(2),ARG(3),ARG(4))

      ELSE IF(COMMAND.EQ.'ucolumn') THEN
          CALL MGOARGUMENTS(1,REST,ARG,ERROR)
          IF(ERROR) GOTO 999
          NC = NINT(ARG(1))
          CALL MGOREADCOL(NC,MAXU,
     $         DATARRAY(DATAPTR(ICHAR('U')-ICHAR('A')+1)),
     $         NAU,ERROR,DATA)

      ELSE IF(COMMAND.EQ.'vcolumn') THEN
         CALL MGOARGUMENTS(1,REST,ARG,ERROR)
         IF(ERROR) GOTO 999
         NC = NINT(ARG(1))
         CALL MGOREADCOL(NC,MAXV,
     $        DATARRAY(DATAPTR(ICHAR('V')-ICHAR('A')+1)),
     $        NAV,ERROR,DATA)

      ELSE IF(COMMAND.EQ.'vfield') THEN
C          CALL MGOTSELECT
          CALL MGOPARSE(REST,PAR,LENPAR,NEXTPAR)
          ICART = 0
          VSCALE = 0
          IF(LENPAR.GT.0) THEN
              CALL MGOARGUMENTS(1,REST,ARG,ERROR)
              IF(ERROR) GOTO 999
              ICART = NINT(ARG(1))
              CALL MGOPARSE(REST(NEXTPAR:),PAR,LENPAR,NXTPAR)
              IF(LENPAR.GT.0) THEN
                  CALL MGOARGUMENTS(1,REST(NEXTPAR:),ARG,ERROR)
                  IF(ERROR) GOTO 999
                  VSCALE = ARG(1)
              END IF
          END IF
          IF(ICART.EQ.0) THEN
             CALL MGOVFPOLAR(
     $            DATARRAY(DATAPTR(ICHAR('X')-ICHAR('A')+1)),
     $            DATARRAY(DATAPTR(ICHAR('Y')-ICHAR('A')+1)),
     $            DATARRAY(DATAPTR(ICHAR('U')-ICHAR('A')+1)),
     $            DATARRAY(DATAPTR(ICHAR('V')-ICHAR('A')+1)),
     $            MIN(NAX,NAY,NAU,NAV),VSCALE)
          ELSE IF(ICART.EQ.1) THEN
             CALL MGOVFCART(
     $            DATARRAY(DATAPTR(ICHAR('X')-ICHAR('A')+1)),
     $            DATARRAY(DATAPTR(ICHAR('Y')-ICHAR('A')+1)),
     $            DATARRAY(DATAPTR(ICHAR('U')-ICHAR('A')+1)),
     $            DATARRAY(DATAPTR(ICHAR('V')-ICHAR('A')+1)),
     $            MIN(NAX,NAY,NAU,NAV),VSCALE)
          ELSE IF(ICART.EQ.2) THEN
             CALL MGOVFSEG(
     $            DATARRAY(DATAPTR(ICHAR('X')-ICHAR('A')+1)),
     $            DATARRAY(DATAPTR(ICHAR('Y')-ICHAR('A')+1)),
     $            DATARRAY(DATAPTR(ICHAR('U')-ICHAR('A')+1)),
     $            DATARRAY(DATAPTR(ICHAR('V')-ICHAR('A')+1)),
     $            MIN(NAX,NAY,NAU,NAV),VSCALE)
          END IF

      ELSE IF(COMMAND.EQ.'3dplot') THEN
          IF(.NOT.INTERNAL) THEN
              call MGOERR('3dplot uses data from MONGO subroutine')
              GOTO 999
          END IF
          CALL MGOARGUMENTS(3,REST,ARG,ERROR)
          IF(ERROR) GOTO 999
          ZOFF = 0
          IF(ARG(3).EQ.0) ARG(3) = 1
C          CALL MGOTSELECT
* Note that the P array is used as a scratch work array here -- UGH
          CALL MGOPLT3D(DATA,NROW,NCOL,
     $         DATARRAY(DATAPTR(ICHAR('P')-ICHAR('A')+1)+1),
     $         ARG(1),ARG(2),1./ARG(3),ZOFF)

      ELSE IF(COMMAND.EQ.'window') THEN
         CALL MGOCOUNTOKEN(REST,NTOK)
         IF(NTOK.EQ.0) THEN
            CALL MGOSUBWINDOW(.TRUE., 0.,0.,0.,0.)
         ELSE IF(NTOK.GT.0) THEN
            CALL MGOARGUMENTS(NTOK,REST,ARG,ERROR)
            IF(ERROR) GOTO 999
            IF(NTOK.EQ.1) THEN
               CALL MGOWINDOW(0,0, NINT(ARG(1)))
            ELSE IF(NTOK.EQ.2) THEN
               CALL MGOWINDOW(NINT(ARG(1)),NINT(ARG(2)),0)
            ELSE IF(NTOK.EQ.3) THEN
               CALL MGOWINDOW(NINT(ARG(1)),NINT(ARG(2)),NINT(ARG(3)))
            ELSE IF(NTOK.EQ.4) THEN
               CALL MGOSUBWINDOW(.FALSE.,ARG(1),ARG(3),ARG(2),ARG(4))
            END IF
         END IF

      ELSE IF(COMMAND.EQ.'while') THEN
          call mgoerr('"while" not yet implemented')

      ELSE IF(COMMAND.EQ.'write') THEN
          CALL MGOPARSE(REST,MACNAME,LENPAR,NEXTPAR)
          CALL MGOPARSE(REST(NEXTPAR:),FILENAME,LENPAR,NEXTPAR)
          IF(LENPAR.EQ.0) THEN
              call MGOERR('Write "macro" "filename"')
              ERROR = .TRUE.
              GOTO 999
          END IF
          CALL MGOWRITEMAC(MACNAME,FILENAME,ERROR)

      ELSE IF(COMMAND.EQ.'xcolumn') THEN
          CALL MGOARGUMENTS(1,REST,ARG,ERROR)
          IF(ERROR) GOTO 999
          NCX = NINT(ARG(1))
          CALL MGOREADCOL(NCX,MAXX,
     $         DATARRAY(DATAPTR(ICHAR('X')-ICHAR('A')+1)),
     $         NAX,ERROR,DATA)

      ELSE IF(COMMAND.EQ.'xlabel') THEN
C          CALL MGOTSELECT
          CALL MGOXLABEL(MGOLENC(REST),REST)

      ELSE IF(COMMAND.EQ.'xlogarithm') THEN
          CALL MGOLOGARITHM( DATARRAY(DATAPTR(ICHAR('X')-ICHAR('A')+1)), 
     $        NAX)

      ELSE IF(COMMAND.EQ.'ycolumn') THEN
          CALL MGOARGUMENTS(1,REST,ARG,ERROR)
          IF(ERROR) GOTO 999
          NCY = NINT(ARG(1))
          CALL MGOREADCOL(NCY,MAXY,
     $         DATARRAY(DATAPTR(ICHAR('Y')-ICHAR('A')+1)),
     $         NAY,ERROR,DATA)

      ELSE IF(COMMAND.EQ.'ylabel') THEN
C          CALL MGOTSELECT
          CALL MGOYLABEL(MGOLENC(REST),REST)

      ELSE IF(COMMAND.EQ.'ylogarithm') THEN
          CALL MGOLOGARITHM( DATARRAY(DATAPTR(ICHAR('Y')-ICHAR('A')+1)), 
     $        NAY)

      ELSE
          call MGOERR2(' No code to execute for', COMMAND)
          ERROR = .TRUE.
      END IF

999   CONTINUE

      IF(ERROR) RETURN
      IF(TERMIDLE) THEN
          CALL MGOTIDLE
      END IF
      RETURN
      END

* Test character string for 0, 1, or 2 array references.
      SUBROUTINE MGOTWOARRAY(REST, I1, I2)
      CHARACTER*(*) REST
      CHARACTER*32 PAR1, PAR2

      CALL MGOPARSE(REST,PAR1,LEN1,NEXTPAR)
      IF(LEN1.EQ.0) GOTO 666
      CALL MGOLOWER(PAR1)
      IF(MGOLENC(PAR1).NE.1 .OR. 
     $     PAR1(1:1).LT.'a' .OR. PAR1(1:1).GT.'z') GOTO 666
      I2 = ICHAR(PAR1(1:1)) - ICHAR('a') + 1

      CALL MGOPARSE(REST(NEXTPAR:),PAR2,LEN2,NEXTPAR)
      IF(LEN2.EQ.0) GOTO 667
      CALL MGOLOWER(PAR2)
      IF(MGOLENC(PAR2).NE.1 .OR. 
     $     PAR2(1:1).LT.'a' .OR. PAR2(1:1).GT.'z') GOTO 667
      I1 = I2
      I2 = ICHAR(PAR2(1:1)) - ICHAR('a') + 1
      RETURN

 666  I2 = ICHAR('y') - ICHAR('a') + 1
 667  I1 = ICHAR('x') - ICHAR('a') + 1
      RETURN
      END
