CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE MGODOT
      INCLUDE 'mongo.par'
      CALL MGOPOINT(NINT(PTYPE)/10,MOD(NINT(PTYPE),10))
      RETURN
      END


      SUBROUTINE MGOPOINT(N,ISTYLE)
      INCLUDE 'mongo.par'

      IF(N.EQ.0) RETURN
      IF(N.EQ.1) THEN
          CALL MGOGRELOCATE(XP,YP)
          CALL MGOGDRAW(XP,YP)
          RETURN
      END IF

      XC = ANINT(XP)
      YC = ANINT(YP)
      DTHETA = 2 * PI / N
      THETA = (3*PI + DTHETA)/2
      CANG = COS(ANGLE*PI/180)
      SANG = SIN(ANGLE*PI/180)

      IF(ISTYLE.EQ.0 .OR. N.EQ.2) THEN
          DO 5 J = 0,N
             DX = EXPX * EXPAND * COS(THETA)
             DY = EXPY * EXPAND * SIN(THETA)
             XA = PXDEF*(DX*CANG - DY*SANG) + XC
             YA = PYDEF*(DX*SANG + DY*CANG) + YC
             IF(J.EQ.0) THEN
                CALL MGOGRELOCATE(XA,YA)
             ELSE
                CALL MGOGDRAW(XA,YA)
             END IF
             THETA = THETA + DTHETA
 5        CONTINUE

      ELSE IF(ISTYLE.EQ.1) THEN
          DO 15 J = 1,N
             DX = EXPX * EXPAND * COS(THETA)
             DY = EXPY * EXPAND * SIN(THETA)
             XA = PXDEF*(DX*CANG - DY*SANG) + XC
             YA = PYDEF*(DX*SANG + DY*CANG) + YC
             CALL MGOGRELOCATE(XA,YA)
             IF(2*(N/2).EQ.N) THEN
                IF(J.GT.N/2) GOTO 999
                CALL MGOGDRAW(2*XC-XA,2*YC-YA)
             ELSE
                CALL MGOGDRAW(XC,YC)
             END IF
             THETA = THETA + DTHETA
 15    CONTINUE

      ELSE IF(ISTYLE.EQ.2) THEN
          STELLAR = .25
          DO 25 J = 0,N
             DX = EXPX * EXPAND * COS(THETA)
             DY = EXPY * EXPAND * SIN(THETA)
             XB = PXDEF*(DX*CANG - DY*SANG) + XC
             YB = PYDEF*(DX*SANG + DY*CANG) + YC
             XMID = STELLAR*(XA + XB - 2*XC) + XC
             YMID = STELLAR*(YA + YB - 2*YC) + YC
             IF(J.EQ.0) THEN
                CALL MGOGRELOCATE(XB,YB)
             ELSE
                CALL MGOGDRAW(XMID,YMID)
                CALL MGOGDRAW(XB,YB)
             END IF
             XA = XB
             YA = YB
             THETA = THETA + DTHETA
 25       CONTINUE

      ELSE IF(ISTYLE.EQ.3) THEN
* Work upwards, raster by raster, from the minimum y value YMIN, which occurs
* at vertex at angle THA, to the maximum y value YMAX (converted to device
* coords as IYMIN and IYMAX). 
* Work around the polygon starting from this vertex. At any one time, there
* are two sides being considered: 
* (1) (XA1,YA1) to (XA2,YA2) goes CCW, starting at angle THA
* (2) (XB1,YB1) to (XB2,YB2) goes  CW, starting at angle THB
* As long as these two sides span the raster being considered, use these
* sides to compute the x limits of the raster making up the point, XA to XB
* As soon as the raster gets higher than one of these sides, (i.e. YA2 or YB2
* is exceeded by the current raster, increment THA or decrement THB by 
* DTHETA and compute a new side.
          YMAX = -1
          YMIN = 1
          DO 31 J = 1,N
             DX = EXPX * COS(THETA + J*DTHETA)
             DY = EXPY * SIN(THETA + J*DTHETA)
             Y = DX*SANG + DY*CANG
             IF(Y.LT.YMIN) THEN
                YMIN = Y
                THA = THETA + J*DTHETA
             END IF
             YMAX = AMAX1(YMAX,Y)
 31       CONTINUE
          IYMAX = INT(EXPAND*PYDEF*YMAX)
          IYMIN = INT(EXPAND*PYDEF*YMIN)

          THB = THA

          DX = EXPX * EXPAND * COS(THA)
          DY = EXPY * EXPAND * SIN(THA)
          XA1 = PXDEF*(DX*CANG - DY*SANG)
          YA1 = PYDEF*(DX*SANG + DY*CANG)
          DX = EXPX * EXPAND * COS(THA+DTHETA)
          DY = EXPY * EXPAND * SIN(THA+DTHETA)
          XA2 = PXDEF*(DX*CANG - DY*SANG)
          YA2 = PYDEF*(DX*SANG + DY*CANG)
          XB1 = XA1
          YB1 = YA1
          DX = EXPX * EXPAND * COS(THB-DTHETA)
          DY = EXPY * EXPAND * SIN(THB-DTHETA)
          XB2 = PXDEF*(DX*CANG - DY*SANG)
          YB2 = PYDEF*(DX*SANG + DY*CANG)

          DO 35 J = IYMIN,IYMAX
          DO 36 I = 1,N
              IF(YA2.GE.J) GOTO 37
              THA = THA + DTHETA
              XA1 = XA2
              YA1 = YA2
              DX = EXPX * EXPAND * COS(THA)
              DY = EXPY * EXPAND * SIN(THA)
              XA2 = PXDEF*(DX*CANG - DY*SANG)
              YA2 = PYDEF*(DX*SANG + DY*CANG)
36        CONTINUE
37        CONTINUE
          DO 38 I = 1,N
              IF(YB2.GE.J) GOTO 39
              THB = THB - DTHETA
              XB1 = XB2
              YB1 = YB2
              DX = EXPX * EXPAND * COS(THB)
              DY = EXPY * EXPAND * SIN(THB)
              XB2 = PXDEF*(DX*CANG - DY*SANG)
              YB2 = PYDEF*(DX*SANG + DY*CANG)
38        CONTINUE
39        CONTINUE
C	write(6,'(i5,8f9.5)') j, xa1, ya1, xa2, ya2, xb1, yb1, xb2, yb2
          XA = XA1 + (XA2-XA1)*(J-YA1)/(YA2-YA1) + XC
          YA = J + YC
          XB = XB1 + (XB2-XB1)*(J-YB1)/(YB2-YB1) + XC
          YB = J + YC
          CALL MGOGRELOCATE(XA,YA)
35        CALL MGOGDRAW(XB,YB)

      END IF

 999  CONTINUE
      XP = XC
      YP = YC
      RETURN
      END
