CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE MGOPRNTINIT
      PARAMETER (NBUF = 2048)
      INTEGER*2 BUF(NBUF)
      INTEGER NCOORD, NVECTOR
      LOGICAL NEW
      COMMON /MGOPRNTBUF/ NCOORD, NVECTOR, BUF, NEW
      DATA NEW /.TRUE./

      NEW = .TRUE.
      RETURN
      END

      SUBROUTINE MGOPRNTLINE(IX1,IY1,IX2,IY2)
      INCLUDE 'mongo.par'
C      INCLUDE 'arrays.par'
      PARAMETER (NBUF = 2048)
      INTEGER*2 BUF(NBUF)
      INTEGER NCOORD, NVECTOR, SIGN
      LOGICAL NEW, DISJOINT
      COMMON /MGOPRNTBUF/ NCOORD, NVECTOR, BUF, NEW
      DATA SIGN /-32768/

******************************************************************************
* Vector file contains pairs of 16 bit numbers according to:                 *
*    Sign 1   Sign 2   Mantissa 1   Mantissa 2   Meaning                     *
*      0        0          x            y        Draw a dot at (x,y)         *
*      1        0          x            y        Relocate at (x,y)           *
*      0        1          x            y        Draw to (x,y)               *
*      1        1        32767        32767      End of vector file          *
*      1        1          0            0        Finish plot, start new page *
*      1        1          1            n        Line weight = n             *
*      1        1          2            n        Line type = n               *
*      1        1          3            n        Color = n (from palette)    *
*      1        1          4            n        Color (red) = n (0-256)     *
*      1        1          5            n        Color (green) = n (0-256)   *
*      1        1          6            n        Color (blue) = n (0-256)    *
*      1        1          7            n        Pointer to string (not used)*
*      1        1          8            n        Fill mode = n               *
* (x,y) are oriented in portrait mode                                        *
******************************************************************************

      IF(NEW) THEN
* Open a new vector file on unit veclun

          NCOORD = 0
          NVECTOR = 0
          LWGT = -1
          LTYP = -1
          ICLR = -1
          ICR = -1
          ICG = -1
          ICB = -1
          LASTX = -1
          LASTY = -1
          IFM = 0
          CALL MGONEWOPEN
          NEW = .FALSE.
      END IF

      IF(LWEIGHT.NE.LWGT) THEN
          LWGT = LWEIGHT
          CALL MGOPRNTSAVE(SIGN + 1, SIGN + LWEIGHT)
      END IF

      IF(LTYPE.NE.LTYP) THEN
          LTYP = LTYPE
          CALL MGOPRNTSAVE(SIGN + 2, SIGN + LTYPE)
      END IF

      IF(ICOLOR.GE.0 .AND. ICOLOR.LT.MAXPALETTE .AND.
     $     (ICOLOR.NE.ICLR .OR. PALETTE(1,ICOLOR).NE.ICR .OR.
     $     PALETTE(2,ICOLOR).NE.ICG .OR. PALETTE(3,ICOLOR).NE.ICB)) THEN
          ICLR = ICOLOR
          ICR = PALETTE(1,ICOLOR)
          ICG = PALETTE(2,ICOLOR)
          ICB = PALETTE(3,ICOLOR)
          CALL MGOPRNTSAVE(SIGN + 4, SIGN + ICR)
          CALL MGOPRNTSAVE(SIGN + 5, SIGN + ICG)
          CALL MGOPRNTSAVE(SIGN + 6, SIGN + ICB)
      END IF

* Is this a zero length line or a zero length dot?
* NOTE: this is not right...  A "fill 0" isn't properly 
* ending a fill and a subsequent relocate to the same position
* is getting treated as zero length continuation of the current "fill 1 1"
* UGH.  Must fix this some day.
      DISJOINT = IX1.NE.LASTX.OR.IY1.NE.LASTY.OR.IFM.NE.FILLMODE

      IF(FILLMODE.NE.IFM) THEN
          IFM = FILLMODE
* If XYSWAPPED some of the bit patterns will be rotated by 90 degrees,
* and psraster needs to know about it.
          NEWFILL = FILLMODE
          IF(XYSWAPPED) NEWFILL = FILLMODE + 2048
          CALL MGOPRNTSAVE(SIGN + 8, SIGN + newfill)
      END IF

* A dot?
      IF(IX1.EQ.IX2.AND.IY1.EQ.IY2 .AND. DISJOINT) THEN
          CALL MGOPRNTSAVE( IX1,  IY1)

* A line?
      ELSE IF(IX2.GT.-65536) THEN
          IF(DISJOINT) THEN
             CALL MGOPRNTSAVE(SIGN + IX1,  IY1)
          END IF
          CALL MGOPRNTSAVE( IX2, SIGN + IY2)

* A forced relocate?
      ELSE
         CALL MGOPRNTSAVE(SIGN + IX1, IY1)
      END IF

      LASTX = IX2
      LASTY = IY2
      NVECTOR = NVECTOR + 1
      RETURN
      END

      SUBROUTINE MGOPRNTSAVE(M1,M2)
      PARAMETER (NBUF = 2048)
      COMMON /MGOPRNTBUF/ NCOORD, NVECTOR, BUF, NEW
      INCLUDE 'luns.par'
      INTEGER*2 BUF(NBUF)
      BUF(NCOORD+1) = M1
      BUF(NCOORD+2) = M2
      NCOORD = NCOORD + 2
      IF(NCOORD.GE.NBUF) THEN
         WRITE(veclun) BUF
         NCOORD = 0
      END IF
      RETURN
      END

      SUBROUTINE MGOPRNTBITINIT(IXA,IYA,IXB,IYB,IALG,IDY,START)
      LOGICAL START
      INTEGER SIGN
      DATA SIGN /-32768/
      IF(START) THEN
         ICODE = 9
         IF(IALG.EQ.0) ICODE = 10
         CALL MGOPRNTLINE(IXA, IYA, -100000, -100000)
         CALL MGOPRNTSAVE(SIGN + ICODE, SIGN + IXA)
         CALL MGOPRNTSAVE(SIGN + ICODE, SIGN + IXB)
         CALL MGOPRNTSAVE(SIGN + ICODE, SIGN + IYA)
         CALL MGOPRNTSAVE(SIGN + ICODE, SIGN + IYB)
* IDY > 0 signifies rotation by 90 degrees (landscape mode)
         CALL MGOPRNTSAVE(SIGN + ICODE, SIGN + IDY)
      ELSE
         CALL MGOPRNTSAVE(SIGN + 14, SIGN + IYB)
      END IF
      RETURN
      END

      SUBROUTINE MGOPRNTBITS(IXA,IYA,NX,NY,BITS)
      INTEGER*2 BITS(NX,NY)
      INTEGER SIGN
      DATA SIGN /-32768/

C      write(6,*) 'prntbits', ixa, iya, nx, ny, bits(nx/2,1)
      CALL MGOPRNTSAVE(SIGN + 11, SIGN + IXA)
      CALL MGOPRNTSAVE(SIGN + 11, SIGN + IYA)

      IF(NY.EQ.1) THEN
         DO 30 I = 0,NX-1,12
            K = 0
            DO 31 J = 1,12
               K = 2*K + BITS(I+J,1)
 31         CONTINUE
            CALL MGOPRNTSAVE(SIGN + 13, SIGN + K)
 30      CONTINUE
      ELSE

         DO 20 J = 1,NY
            DO 21 I = 1,NX,4
               K = BITS(I,J) + 10*BITS(I+1,J) + 
     $              100*BITS(I+2,J) + 1000*BITS(I+3,J)
               CALL MGOPRNTSAVE(SIGN + 12, SIGN + K)
 21         CONTINUE
 20      CONTINUE

C A code fragment to do square bitmaps without rotating
C Needs XYSWAP, no rotate and translate in BITINIT, LY-Y -> x', X ->y'
C both here and for clip
C      IF(XYSWAP) THEN
C         DO 10 I = 1,NX
C            DO 11 J = NY-3,1,-4
C               K = BITS(I,J+3) + 10*BITS(I,J+2) + 
C     $              100*BITS(I,J+1) + 1000*BITS(I,J)
C               CALL MGOPRNTSAVE(SIGN + 12, SIGN + K)
C 11         CONTINUE
C 10      CONTINUE

      END IF
      RETURN
      END

      SUBROUTINE MGOPRNTPLOT(NVEC)
      PARAMETER (NBUF = 2048)
      INTEGER*2 BUF(NBUF)
      INTEGER NCOORD, NVECTOR
      LOGICAL NEW
      INCLUDE 'mongo.par'
      INCLUDE 'luns.par'
      COMMON /MGOPRNTBUF/ NCOORD, NVECTOR, BUF, NEW

      IF(NUMDEV.GE.0) THEN
          call mgoerr('Current output device is a terminal')
          RETURN
      END IF
      IF(NVECTOR.EQ.0) THEN
          call mgoerr('No output to printer yet')
          RETURN
      END IF
      IF(NCOORD.GT.0) THEN
          BUF(NCOORD+1) = -1
          BUF(NCOORD+2) = -1
          WRITE(veclun) BUF
      END IF
      CLOSE(veclun)
      IDEV = (-NUMDEV+1)/2
      CALL MGOGORASTER(IDEV)
      NVEC = NVECTOR
      NEW = .TRUE.
      RETURN
      END
