CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE MGOSETPTYPE(P)
      INCLUDE 'mongo.par'
      PTYPE = P
      RETURN
      END

      SUBROUTINE MGOSETLTYPE(N)
      INCLUDE 'mongo.par'
      IF(TERMOUT) THEN
          CALL MGOTLTYPE(N)
      ENDIF
      LTYPE = N
      RETURN
      END

      SUBROUTINE MGOSETLWEIGHT(N)
      INCLUDE 'mongo.par'
      IF(TERMOUT) THEN
          CALL MGOTLWEIGHT(N)
      ENDIF
      LWEIGHT = N
      RETURN
      END

      SUBROUTINE MGOSETANGLE(ARG)
      INCLUDE 'mongo.par'
      ANGLE = ARG
      RETURN
      END

      SUBROUTINE MGOSETSLOPE(XA,YA,XB,YB)
      INCLUDE 'mongo.par'
      DX = (XB-XA)/(X2-X1)*(GX2-GX1)
      DY = (YB-YA)/(Y2-Y1)*(GY2-GY1)
      IF(DX.EQ.0.AND.DY.EQ.0) THEN
          ANGLE = 0
      ELSE
          ANGLE = 180/PI*ATAN2(DY,DX)
      END IF
      RETURN
      END

      SUBROUTINE MGOSETEXPAND(ARG)
      INCLUDE 'mongo.par'
      IF(ARG.GE.0) THEN
         EXPAND = ARG
      ELSE
         IF(X1.NE.X2) THEN
            EXPAND = -ARG*(GX2-GX1)/ABS(X2-X1)/PXDEF
         ELSE
            EXPAND = 1
         END IF
      END IF
      EXPX = 1
      EXPY = 1
      RETURN
      END

      SUBROUTINE MGOSETDIFFEXP(ARG1, ARG2)
      INCLUDE 'mongo.par'
      IF(ARG1.GE.0 .AND. ARG2.GE.0) THEN
         EXPX = ARG1
         EXPY = ARG2
      ELSE
         IF(X1.EQ.X2 .OR. Y1.EQ.Y2) THEN
            CALL MGOERR('Must have unequal plot limits')
            RETURN
         END IF
         EXPX = -ARG1*(GX2-GX1)/ABS(X2-X1)/PXDEF
         EXPY = -ARG2*(GY2-GY1)/ABS(Y2-Y1)/PYDEF
         IF(ARG1.GE.0) EXPX = (ARG1 / ABS(ARG2)) * EXPY
         IF(ARG2.GE.0) EXPY = (ARG2 / ABS(ARG1)) * EXPX
      END IF
      EXPAND = SQRT(ABS(EXPX*EXPY))
      IF(EXPAND.EQ.0) EXPAND = 1
      IF(EXPAND.EQ.1) EXPAND = 1.0001
      EXPX = EXPX / EXPAND
      EXPY = EXPY / EXPAND
      RETURN
      END

      SUBROUTINE MGOSETFILL(IFILL,IRELOC)
      INCLUDE 'mongo.par'
      IF(TERMOUT) THEN
          CALL MGOTFILL(IFILL,IRELOC)
      ENDIF
      FILLMODE = IFILL + 1024*IRELOC
      RETURN
      END

      SUBROUTINE MGOSETLIM(XA,YA,XB,YB)
      INCLUDE 'mongo.par'
      IF(XA.EQ.XB) THEN
          X1 = X1
          X2 = X1+1
      ELSE
          X1 = XA
          X2 = XB
      END IF
      IF(YA.EQ.YB) THEN
          Y1 = Y1
          Y2 = Y1+1
      ELSE
          Y1 = YA
          Y2 = YB
      END IF
      RETURN
      END

      SUBROUTINE MGOSETLOC(XA,YA,XB,YB)
      INCLUDE 'mongo.par'
      IF(YB.LE.YA .OR. XB.LE.XA) THEN
         CALL MGOERR('Cannot set GX2<=GX1 or GY2<=GY1')
         RETURN
      END IF
      GX1 = XA
      GY1 = YA
      GX2 = XB
      GY2 = YB
      RETURN
      END

      SUBROUTINE MGOSETPHYSICAL(XA,YA,XB,YB)
      INCLUDE 'mongo.par'
      IF(YB.LE.YA .OR. XB.LE.XA) THEN
         CALL MGOERR('Cannot set LX2<=LX1 or LY2<=LY1')
         RETURN
      END IF
      LX1 = NINT(XA)
      LY1 = NINT(YA)
      LX2 = NINT(XB)
      LY2 = NINT(YB)
      RETURN
      END

      SUBROUTINE MGOSETCURS(XA,YA)
      INCLUDE 'mongo.par'
      CXP = XA
      CYP = YA
      RETURN
      END

      SUBROUTINE MGOSETCOLOR(N)
      INCLUDE 'mongo.par'
C      INCLUDE 'arrays.par'
      IF(N.LT.0.OR.N.GT.MAXPALETTE-1) RETURN
      IF(TERMOUT) THEN
          CALL MGOTCOLOR(N)
      ENDIF
      ICOLOR = N
      RETURN
      END

      SUBROUTINE MGOSETPALETTE(N,R,G,B)
      INCLUDE 'mongo.par'
C      INCLUDE 'arrays.par'
      IF(N.LT.0.OR.N.GT.MAXPALETTE-1) RETURN
      PALETTE(1,N) = MAX(0,MIN(255,NINT(R*255)))
      PALETTE(2,N) = MAX(0,MIN(255,NINT(G*255)))
      PALETTE(3,N) = MAX(0,MIN(255,NINT(B*255)))
      IF(TERMOUT) THEN
          CALL MGOTPALETTE(N)
      ENDIF
      ICOLOR = N
      RETURN
      END


      SUBROUTINE MGOSHOW(REST,ERROR)
      INCLUDE 'arrays.par'
      INCLUDE 'mongo.par'
      INCLUDE 'luns.par'
      CHARACTER*132 LINE
      CHARACTER*(*) REST
      LOGICAL ERROR
      INTEGER NCH(7)
      CHARACTER*20 F(7)
      CHARACTER*20 BLANK
      CHARACTER*1 BSL
      DATA BLANK /'                    '/

      IF(REST(1:1).NE.' ') THEN
         CALL MGOSHOWUVAR(REST,ERROR)
         RETURN
      END IF

      ERROR = .FALSE.

      BSL = CHAR(92)
      UXP = X1 + (X2-X1)*(XP-GX1)/(GX2-GX1)
      UYP = Y1 + (Y2-Y1)*(YP-GY1)/(GY2-GY1)
      NFIG = 3
      CALL MGOFPFMT(UXP,NFIG,NCH(1),F(1))
      CALL MGOFPFMT(UYP,NFIG,NCH(2),F(2))
      CALL MGOFPFMT(X1,NFIG,NCH(3),F(3))
      CALL MGOFPFMT(X2,NFIG,NCH(4),F(4))
      CALL MGOFPFMT(Y1,NFIG,NCH(5),F(5))
      CALL MGOFPFMT(Y2,NFIG,NCH(6),F(6))
      LINE = 'User   (' // F(1)(:NCH(1)) // ',' // F(2)(:NCH(2)) // ')'
     1    // BLANK(:19-NCH(1)-NCH(2)) // 'User  '
     1    // BLANK(:9-NCH(3))
     1    // F(3)(:NCH(3)) // ' (x)' // F(4)(:NCH(4))
     1    // BLANK(:19-NCH(4)-NCH(5))
     1    // F(5)(:NCH(5)) // ' (y)' // F(6)(:NCH(6))
      call mgout(line)
      CALL MGOIFMT(NINT(XP),NFIG,NCH(1),F(1))
      CALL MGOIFMT(NINT(YP),NFIG,NCH(2),F(2))
      CALL MGOIFMT(NINT(GX1),NFIG,NCH(3),F(3))
      CALL MGOIFMT(NINT(GX2),NFIG,NCH(4),F(4))
      CALL MGOIFMT(NINT(GY1),NFIG,NCH(5),F(5))
      CALL MGOIFMT(NINT(GY2),NFIG,NCH(6),F(6))
      LINE = 'Device (' // F(1)(:NCH(1)) // ',' // F(2)(:NCH(2)) // ')'
     1    // BLANK(:19-NCH(1)-NCH(2)) // 'Device'
     1    // BLANK(:8-NCH(3))
     1    // F(3)(:NCH(3)) // ' (gx)' // F(4)(:NCH(4))
     1    // BLANK(:18-NCH(4)-NCH(5))
     1    // F(5)(:NCH(5)) // ' (gy)' // F(6)(:NCH(6))
      call mgout(line)
      CALL MGOFPFMT(CXP,NFIG,NCH(1),F(1))
      CALL MGOFPFMT(CYP,NFIG,NCH(2),F(2))
      CALL MGOIFMT(LX1,NFIG,NCH(3),F(3))
      CALL MGOIFMT(LX2,NFIG,NCH(4),F(4))
      CALL MGOIFMT(LY1,NFIG,NCH(5),F(5))
      CALL MGOIFMT(LY2,NFIG,NCH(6),F(6))
      LINE = 'Cursor (' // F(1)(:NCH(1)) // ',' // F(2)(:NCH(2)) // ')'
     1    // BLANK(:19-NCH(1)-NCH(2)) // 'Limit '
     1    // BLANK(:8-NCH(3))
     1    // F(3)(:NCH(3)) // ' (lx)' // F(4)(:NCH(4))
     1    // BLANK(:18-NCH(4)-NCH(5))
     1    // F(5)(:NCH(5)) // ' (ly)' // F(6)(:NCH(6))
      call mgout(line)
      WRITE(line,1004) EXPAND,ANGLE,LTYPE,LWEIGHT,PTYPE,NUMDEV
1004  FORMAT(1X,'EXPAND =',F5.1,'  ANGLE =',F6.1,
     1    '  LTYPE =',I2,'  LWEIGHT =',I2,
     1    '  PTYPE =',F5.1,'  NUMDEV =',I3)
      call mgout(line)
      NFIG = 4
      CALL MGOIFMT(LINE1,NFIG,NCH(1),F(1))
      CALL MGOIFMT(LINE2,NFIG,NCH(2),F(2))
      CALL MGOFPFMT(USERVAR(1),NFIG,NCH(3),F(3))
      CALL MGOFPFMT(USERVAR(2),NFIG,NCH(4),F(4))
      CALL MGOFPFMT(USERVAR(3),NFIG,NCH(5),F(5))
      CALL MGOFPFMT(USERVAR(4),NFIG,NCH(6),F(6))
      CALL MGOFPFMT(USERVAR(5),NFIG,NCH(7),F(7))
      NBL = 80 - 18 - 8 - NCH(3) - NCH(4) - NCH(5) - NCH(6) - NCH(7)
      NBL = MAX(NBL/4,1)
      LINE = 'LINES' // F(1)(:NCH(1)) // F(2)(:NCH(2))
     1    // BLANK(:13-NCH(1)-NCH(2)) // BSL//'0-'//BSL//'4 = '
     1    // F(3)(:NCH(3)) // BLANK(:NBL)
     1    // F(4)(:NCH(4)) // BLANK(:NBL)
     1    // F(5)(:NCH(5)) // BLANK(:NBL)
     1    // F(6)(:NCH(6)) // BLANK(:NBL)
     1    // F(7)(:NCH(7))
      call mgout(line)
      RETURN
      END

      SUBROUTINE MGOFPFMT(ARG,NFIG,NCHAR,FIELD)
      CHARACTER*3 FSPEC
      CHARACTER*20 FMT
      CHARACTER*(*) FIELD
      VALUE = ABS(ARG)
      IF(VALUE.EQ.0) THEN
          NDEC = NFIG
          NCHAR = NFIG + 3
          FSPEC = '1PF'
      ELSE IF(VALUE.LT.1E6.AND.VALUE.GT.1E-4) THEN
          EXPO = ALOG10(VALUE)
          IEXPO = IFIX(EXPO)
          IF(EXPO.LT.0) IEXPO = IEXPO - 1
          NDEC = MAX(NFIG-IEXPO-1,0)
          NCHAR = NDEC + 2 + MAX(IEXPO+1,0)
          FSPEC = '0PF'
      ELSE
          NDEC = NFIG - 1
          NCHAR = NFIG + 6
          FSPEC = '1PE'
      END IF
      WRITE(FMT,1000) FSPEC, NCHAR, NDEC
1000  FORMAT('(',A,I2,'.',I2,')')
      WRITE(FIELD,FMT) ARG
      RETURN
      END

      SUBROUTINE MGOIFMT(IARG,NFIG,NCHAR,FIELD)
      CHARACTER*20 FMT
      CHARACTER*(*) FIELD
      VALUE = ABS(FLOAT(IARG))
      IF(VALUE.EQ.0) THEN
          NCHAR = 2
      ELSE
          IEXPO = IFIX(ALOG10(VALUE))
          NCHAR = IEXPO + 2
      END IF
      WRITE(FMT,1000) NCHAR
1000  FORMAT('(I',I2,')')
      WRITE(FIELD,FMT) IARG
      RETURN
      END

      SUBROUTINE MGOINFO(X0,Y0,ITELL)
      INCLUDE 'mongo.par'
      CHARACTER*200 LINE

      I = MGOINFOLINE(0,X0,Y0,NLINE,LINE)
      IF(I.LT.0) THEN
         CALL MGOERR('Both X and Y arrays must exist:')
         RETURN
      END IF
      USERVAR(1) = I
      IF(ITELL.EQ.0) RETURN

      IF(NLINE.GT.80) THEN
         K = 80
 10      IF(K.GT.10 .AND. LINE(K:K).NE.'=') THEN
            K = K - 1
            GOTO 10
         END IF
         CALL MGOUT(LINE(:K-5))
         LINE(K-7:K-4) = '    '
         CALL MGOUT(LINE(K-7:NLINE))
      ELSE
         CALL MGOUT(LINE(:NLINE))
      END IF

      RETURN
      END


      FUNCTION MGOINFOLINE(MINI,X0,Y0,NLINE,LINE)
      INCLUDE 'arrays.par'
      INCLUDE 'mongo.par'
      INCLUDE 'luns.par'
      CHARACTER*(*) LINE
      CHARACTER*20 F
      CHARACTER*40 PP
      REAL*8 CODE
      IF(NAX.EQ.0.OR.NAY.EQ.0) THEN
         mgoinfoline = -1
         return
      END IF
      GX0 = GX1 + (X0-X1)*(GX2-GX1)/(X2-X1)
      GY0 = GY1 + (Y0-Y1)*(GY2-GY1)/(Y2-Y1)
      
      DO 10 K = 1,MIN(NAX,NAY)
         X = DATARRAY(DATAPTR(ICHAR('X')-ICHAR('A')+1)+K-1)
         Y = DATARRAY(DATAPTR(ICHAR('Y')-ICHAR('A')+1)+K-1)
         GX = GX1 + (X-X1)*(GX2-GX1)/(X2-X1)
         GY = GY1 + (Y-Y1)*(GY2-GY1)/(Y2-Y1)
         DIST = (GX-GX0)*(GX-GX0) + (GY-GY0)*(GY-GY0)
         IF(K.EQ.1) THEN
            DMIN = DIST
            I = K
         ELSE IF(DIST.LT.DMIN) THEN
            DMIN = DIST
            I = K
         END IF
 10   CONTINUE
      MGOINFOLINE = I

      NFIG = 4
      CALL MGOIFMT(   I ,NFIG,NCH,F)
      LINE = F(:NCH) // ':'
      NLINE = NCH + 1

      IF(NAX.GE.I) THEN
         X = DATARRAY(DATAPTR(ICHAR('X')-ICHAR('A')+1)+I-1)
         CALL MGOFPFMT(X,NFIG,NCH,F)
         LINE(NLINE+1:) = ' X = '//F(:NCH)
         NLINE = NLINE + NCH + 5
      END IF

      IF(NAY.GE.I) THEN
         Y = DATARRAY(DATAPTR(ICHAR('Y')-ICHAR('A')+1)+I-1)
         CALL MGOFPFMT(Y,NFIG,NCH,F)
         LINE(NLINE+1:) = ', Y = '//F(:NCH)
         NLINE = NLINE + NCH + 6
      END IF

      IF(NAU.GE.I.AND.MINI.EQ.0) THEN
         U = DATARRAY(DATAPTR(ICHAR('U')-ICHAR('A')+1)+I-1)
         CALL MGOFPFMT(U,NFIG,NCH,F)
         LINE(NLINE+1:) = ', U = '//F(:NCH)
         NLINE = NLINE + NCH + 6
      END IF

      IF(NAV.GE.I.AND.MINI.EQ.0) THEN
         V = DATARRAY(DATAPTR(ICHAR('V')-ICHAR('A')+I))
         CALL MGOFPFMT(V,NFIG,NCH,F)
         LINE(NLINE+1:) = ', V = '//F(:NCH)
         NLINE = NLINE + NCH + 6
      END IF

      IF(NAE.GE.I.AND.MINI.EQ.0) THEN
         ERR = DATARRAY(DATAPTR(ICHAR('E')-ICHAR('A')+1)+I-1)
         CALL MGOFPFMT(ERR,NFIG,NCH,F)
         LINE(NLINE+1:) = ', E = '//F(:NCH)
         NLINE = NLINE + NCH + 6
      END IF

      IF(NAP.GE.I.AND.MINI.EQ.0) THEN
         CODE = IDATARRAY(DATAPTR(ICHAR('P')-ICHAR('A')+1)+I-1)
         CALL MGOPTDECODE(NSIDE,ISTYLE,EXPO,ANG,ICOL,CODE)
         IF(NSIDE.LT.0) THEN
            PP = '*/*/'
            NP = 4
         ELSE
            CALL MGOIFMT(NSIDE,NFIG,NCH,F)
            PP = F(:NCH) // '/'
            NP = NCH + 1
            CALL MGOIFMT(ISTYLE,NFIG,NCH,F)
            PP(NP+1:) = F(:NCH) // '/'
            NP = NP + NCH + 1
         END IF
         IF(EXPO.LT.-100) THEN
            PP(NP+1:) = '*/'
            NP = NP + 2
         ELSE
            CALL MGOFPFMT(EXPO,3,NCH,F)
            PP(NP+1:) = F(:NCH) // '/'
            NP = NP + NCH + 1
         END IF
         IF(ICOL.LT.0) THEN
            PP(NP+1:) = '*/'
            NP = NP + 2
         ELSE
            CALL MGOIFMT(ICOL,NFIG,NCH,F)
            PP(NP+1:) = F(:NCH) // '/'
            NP = NP + NCH + 1
         END IF
         IF(ANG.LT.-100) THEN
            PP(NP+1:) = '*'
            NP = NP + 1
         ELSE
            CALL MGOIFMT(NINT(ANG),NFIG,NCH,F)
            PP(NP+1:) = F(:NCH)
            NP = NP + NCH
         END IF
         LINE(NLINE+1:) = ', P = '//PP(:NP)
         NLINE = NLINE + NP + 7
      END IF

      IF(I.LE.NAL) THEN
         L = MGOLENC(AUTOLABEL(I))
         LINE(NLINE+1:) = ', L = "'//AUTOLABEL(I)(:L)//'"'
         NLINE = NLINE + L + 8
      END IF

      RETURN
      END


