CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
* Wrapper to use mongo to look at fits files
      parameter (maxhead=360, maxdata=2048*2080)
      character*80 header(maxhead), fname
      integer*2 idata(maxdata)
      real rdata(maxdata/2)
      logical firstime
      equivalence (data,rdata)
      data firstime /.true./

* See if there is a command argument, if so use it as an input file
      nx = 0
      ny = 0
      ncom = 0
      if(iargc(0).ne.0) then
         call getarg(1,fname)
 100     continue
         nhead = maxhead
         call rffile(nhead, header, bscale, bzero, nx, ny, idata, fname)
         if(nx*ny.gt.maxdata/2) then
            write(6,*) 'File is too large:', nx, ny
            goto 10
         end if
         do 1 i = nx*ny,1,-1
            k = idata(i)
            if(k.lt.0) k = k + 65536
            rdata(i) = bscale*k + bzero
            if(i.eq.nx*ny) then
               big = rdata(nx*ny)
               small = rdata(nx*ny)
            else
               big = amax1(big,rdata(i))
               small = amin1(small,rdata(i))
            end if
 1       continue
         write(6,1001) fname(:mgolenc(fname)), nx, ny
 1001    format('Fits file ',a,' read, dimensions ',i5,' x ',i5)
         if(big.gt.1e6.or.small.lt.-1e6) then
            write(6,1002) small, big
 1002       format('  min/max = ',1p2g11.3)
         else
            write(6,1003) small, big
 1003       format('  min/max = ',2f11.3)
         end if
      end if
 10   continue

      write(header(1),1000) 'set \\98', nx
      write(header(2),1000) 'set \\99', ny
 1000 format(a,i5)
      if(firstime) then
         firstime = .false.
         header(3) = 'define sprop'
         header(4) = 'set \\0 gx2 - gx1'
         header(5) = 'set \\0 \\0 / &1'
         header(6) = 'set \\1 gy2 - gy1'
         header(7) = 'set \\1 \\1 / &2'
         header(8) = 'set \\0 \\0 min \\1'
         header(9) = 'set gx2 \\0 * &1'
         header(10) = 'set gx2 gx2 + gx1'
         header(11) = 'set gy2 \\0 * &2'
         header(12) = 'set gy2 gy2 + gy1'
         header(13) = 'end'

         header(14) = 'define proportion'
         header(15) = 'sprop \\98 \\99'
         header(16) = 'end'
         ncom = 16
      else
         ncom = 2
      end if

      call mongo(ncom, header, nx, ny, rdata)

      write(6,6000)
 6000 format('Enter a new filename or ^D to exit: ',$)
      read(5,'(a)',end=999) fname
      goto 100

 999  stop
      end
