/*CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                  Mongo Interactive Graphics Software                    CC
CC                 Copyright (c) 1987, 1994 - John Tonry.                  CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC*/
#include <stdio.h>

#define MIN(a,b) (((a) < (b)) ? (a) : (b))
#define MAX(a,b) (((a) > (b)) ? (a) : (b))
#define ABS(a) (((a) > 0) ? (a) : -(a))

int width, height, minify;	       /* last size of window */
int waiting_for_cursor;		       /* flag for when cursor is on */
int last_coord_point;

mgoxwinselect_()
{
}

mgoxwinopen_(winit,hinit,minit,c,ncolors,palette)
int *winit, *hinit, *minit, *c, *ncolors;
short int *palette;
{
  mgxinit(winit,hinit,minit,c,ncolors,palette);
  mgxrefresh(0);		/* Flush out any Expose events */
/*
  fprintf(stderr,"Window created %d %d %d\n",*winit, *hinit, *minit);
*/
  return(0);
}  

mgoxwinvec_(x1,y1,x2,y2)
int *x1, *x2, *y1, *y2 ;
{
  int f;
  f = minify == 0 ? 1 : ABS(minify);
  mgxrelocate(*x1/f,*y1/f);
  mgxdraw(*x2/f,*y2/f);
}

/* Write n characters from the string c starting at (x,y) */
mgoxwinchar_(x,y,n,c,clen)
int *x, *y, *n, clen ;
char *c ;
{
  int l = *n, f;
  while(l > 0 && (c[l-1] == ' ' || c[l-1] == '\0')) l--;
  c[l] = '\0';
  f = minify == 0 ? 1 : ABS(minify);
  mgxstring(*x/f,*y/f,c);
}

/* If r = 0, put the cursor at x,y; if r=1, wait on mouse and return x,y */
mgoxwincurs_(x,y,r, x0, dx, y0, dy)
int *x, *y, *r;
float *x0, *dx, *y0, *dy;
{
  int f;
  f = minify == 0 ? 1 : ABS(minify);
  if(*r == 0) {
    mgxwarp(MIN(width-1,MAX(0,*x/f)), MIN(height-1,MAX(0,*y/f)));
  } else {
    mgxcursor(*r, x, y, x0, dx, y0, dy);
    *x = *x * f;
    *y = *y * f;
  }
}

/* Erase the graphics window */
mgoxwinerase_()
{
  mgxerase();
}

/* Idle the graphics subwindow */
mgoxwinidle_()
{
  mgxidle();
}

/* Close the graphics subwindow */
mgoxwinclose_()
{
}

/* Set the current color */
mgoxwincolor_(c)
int *c;
{
  mgxselcol(*c);
}

/* Add to the current palette */
mgoxwinpalette_(c,palette)
int *c;
short int *palette;
{
  mgxpaladd(*c, palette);
}

/* Set the fill mode */
mgoxwinfill_(fmode, rmode)
int *fmode, *rmode;
{
  mgxsetfill(*fmode, *rmode);
}

/* Set the current line type */
mgoxwinltype_(t)
int *t;
{
  mgxltype(*t);
}

/* Set the current line weight */
mgoxwinlweight_(w)
int *w;
{
  mgxlweight(*w);
}

/* Tell Mongo that the window was resized */
mgoxwinresize(w, h)
int w, h;
{
  mgoxresize_(&w, &h);
}
